
       IDENTIFICATION DIVISION.
       PROGRAM-ID. CONTROL10-1.
       INSTALLATION. INSTITUTO DE BASAURI 1.
       DATE-WRITTEN. 2-4-1988.
       DATE-COMPILED.
       SECURITY. MECANIZACION EXCLUSIVAMENTE.
       REMARKS. ESTE PROGRAMA OBTIENE LOS IMPORTES, DEDUCCIONES
                Y LIQUIDOS DEL PERSONAL SOBRE LAS HORAS SEMANALES
                DE TRABAJO CON VARIACION EN LOS PORCENTAJES.

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-PC.
       OBJECT-COMPUTER. IBM-PC.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT PERSONAL ASSIGN TO DISK.
           SELECT NOMINA   ASSIGN TO PRINTER.

       DATA DIVISION.
       FILE SECTION.
       FD PERSONAL LABEL RECORDS OMITTED
                   DATA RECORD IS EMPLEADO.
       01 EMPLEADO.
          03 FILLER    PIC X(5).
          03 NUM-EMP   PIC 9(5).
          03 NOM-EMP   PIC X(20).
          03 PTS-HORA  PIC 9(4).
          03 NUM-HORAS PIC 99V99.
          03 DEDUCCION PIC 9(4).
          03 FILLER    PIC X(43).
       FD NOMINA LABEL RECORDS  OMITTED
                 DATA RECORD IS AREA-IMP.
       01 AREA-IMP PIC X(120).
       WORKING-STORAGE SECTION.
       77 WIMPORTE               PIC 9(6) VALUE ZEROS.
       77 WRETENCION             PIC 9(5) VALUE ZEROS.
       77 WLIQUIDO               PIC 9(6) VALUE ZEROS.
       77 ACUMULADOR-IMPORTES    PIC 9(9) VALUE ZEROS.
       77 ACUMULADOR-RETENCIONES PIC 9(9) VALUE ZEROS.
       77 ACUMULADOR-DEDUCCIONES PIC 9(9) VALUE ZEROS.
       77 ACUMULADOR-LIQUIDOS    PIC 9(9) VALUE ZEROS.
       01 CAB1.
          03 FILLER PIC X(10) VALUE SPACES.
          03 FILLER PIC X(41) JUST RIGHT .
       01 CAB2.
          03 FILLER PIC X(15) JUST RIGHT VALUE "NUME.".
          03 FILLER PIC X(36) JUST RIGHT VALUE "PTS    NUME.".
       01 CAB3.
          03 FILLER PIC X(23) JUST RIGHT VALUE "EMPLE  NOMBRE".
          03 FILLER PIC X(61) JUST RIGHT VALUE
             "HORA   HORAS  IMPORTE  RETEN.  DEDUC  LIQUIDO".
       01 DETALLE.
          03 FILLER      PIC X(10) VALUE SPACES.
          03 D-NUM-EMP   PIC 9(5).
          03 FILLER      PIC XX VALUE SPACES.
          03 D-NOM-EMP   PIC X(20).
          03 FILLER      PIC XX VALUE SPACES.
          03 D-PTS-HORA  PIC Z.ZZ9.
          03 FILLER      PIC XX VALUE SPACES.
          03 D-NUM-HORAS PIC ZZ.99.
          03 FILLER      PIC XX VALUE SPACES.
          03 D-IMPORTE   PIC ZZZ.ZZ9.
          03 FILLER      PIC XX VALUE SPACES.
          03 D-RETENCION PIC ZZ.ZZ9.
          03 FILLER      PIC XX VALUE SPACES.
          03 D-DEDUCCION PIC Z.ZZ9.
          03 FILLER      PIC XX VALUE SPACES.
          03 D-LIQUIDO   PIC ZZZ.ZZ9.
       01 CAB-T.
          03 FILLER      PIC X(10) VALUE SPACES.
          03 T-DENOMI    PIC X(15).
          03 T-TOTAL     PIC ZZZ.ZZZ.ZZ9.

       PROCEDURE DIVISION.
       COMENZAR.
           OPEN INPUT PERSONAL.
           OPEN OUTPUT NOMINA.
           WRITE AREA-IMP FROM CAB1 AFTER ADVANCING PAGE.
           WRITE AREA-IMP FROM CAB2 AFTER ADVANCING 4 LINES.
           WRITE AREA-IMP FROM CAB3 AFTER ADVANCING 1 LINES.
       LEER.
           READ PERSONAL AT END GO TO LINEAS-FINALES.
           EXAMINE PTS-HORA REPLACING LEADING SPACES BY ZEROS.
           IF PTS-HORA NOT NUMERIC GO TO ERROR-DATOS.
           EXAMINE NUM-HORAS REPLACING LEADING SPACES BY ZEROS.
           IF NUM-HORAS NOT NUMERIC GO TO ERROR-DATOS.
           EXAMINE DEDUCCION REPLACING LEADING SPACES BY ZEROS.
           IF DEDUCCION NOT NUMERIC GO TO ERROR-DATOS.
           MOVE NUM-EMP TO D-NUM-EMP.
           MOVE NOM-EMP TO D-NOM-EMP.
           MOVE PTS-HORA TO D-PTS-HORA.
           MOVE NUM-HORAS TO D-NUM-HORAS.
           COMPUTE WIMPORTE = PTS-HORA * NUM-HORAS.
           IF WIMPORTE > 0 AND WIMPORTE < 5001
              COMPUTE WRETENCION ROUNDED = 0,05 * WIMPORTE
              ELSE
              IF WIMPORTE > 5000 AND WIMPORTE < 10001
                 COMPUTE WRETENCION ROUNDED = 0,07 * WIMPORTE
                 ELSE
                 IF WIMPORTE > 10000 AND WIMPORTE < 50001
                    COMPUTE WRETENCION ROUNDED = 0,15 * WIMPORTE
                    ELSE
                    IF WIMPORTE > 50000
                       COMPUTE WRETENCION ROUNDED = 0,25 * WIMPORTE.
           SUBTRACT WRETENCION DEDUCCION FROM WIMPORTE GIVING WLIQUIDO.
           MOVE WIMPORTE TO D-IMPORTE.
           MOVE WRETENCION TO D-RETENCION.
           MOVE DEDUCCION TO D-DEDUCCION.
           MOVE WLIQUIDO TO D-LIQUIDO.
           WRITE AREA-IMP FROM DETALLE AFTER ADVANCING 2 LINES.
           ADD WIMPORTE TO ACUMULADOR-IMPORTES.
           ADD WRETENCION TO ACUMULADOR-RETENCIONES.
           ADD DEDUCCION TO ACUMULADOR-DEDUCCIONES.
           ADD WLIQUIDO TO ACUMULADOR-LIQUIDOS.
           GO TO LEER.
       LINEAS-FINALES.
           MOVE "TOTAL  DE IMPORTES  " TO T-DENOMI.
           MOVE ACUMULADOR-IMPORTES TO T-TOTAL.
           WRITE AREA-IMP FROM CAB-T AFTER ADVANCING 4 LINES.
           MOVE "TOTAL DE RETENCIONES " TO T-DENOMI.
           MOVE ACUMULADOR-RETENCIONES TO T-TOTAL.
           WRITE AREA-IMP FROM CAB-T AFTER ADVANCING 4 LINES.
           MOVE "TOTAL DE DEDUCCIONES " TO T-DENOMI.
           MOVE ACUMULADOR-DEDUCCIONES TO T-TOTAL.
           WRITE AREA-IMP FROM CAB-T AFTER ADVANCING 4 LINES.
           MOVE "TOTAL DE LIQUIDOS    " TO T-DENOMI.
           MOVE ACUMULADOR-LIQUIDOS TO T-TOTAL.
           WRITE AREA-IMP FROM CAB-T AFTER ADVANCING 4 LINES.
           CLOSE PERSONAL NOMINA.
           STOP RUN.
       ERROR-DATOS.
           DISPLAY "DATOS NO NUMERICOS.".
           GO TO LEER.


