



       IDENTIFICATION DIVISION.
        PROGRAM-ID. PROYECTO.
        AUTHOR. ALVARO CANTEIRO MARTINEZ.
        INSTALLATION. PORTAL DE ACM.
        DATE-WRITTEN.  29-06-1992.
        DATE-COMPILED. 17-07-1992.
        SECURITY. ESTE PROGRAMA PUEDE SER UTILIZADO LIBREMENTE.
        REMARKS. MANTENIMIENTO Y GESTION DE FICHEROS DE UNA 
                 LAVANDERIA.

      ***********************************************************
      * ESTE PROGRAMA DESARROLLA EL MANTENIMIENTO Y GESTION DE  *
      *            FICHEROS SECUENCIALES, INCLUYENDO:           *
      * BAJAS, ALTAS, MODIFICACIONES, CONSULTAS POR CODIGO Y POR*
      *  EMPRESA INCLUYENDO ADEMAS LA POSIBILIDAD DE UN LISTADO *
      *    POR IMPRESORA DEL FICHERO Y LA CREACION DEL MISMO.   *
      ***********************************************************

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER. IBM-PC.
       OBJECT-COMPUTER. IBM-PC.  
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.

           SELECT MAESTRO ASSIGN TO RANDOM "CLIENTES.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS CLIENTEM
               ALTERNATE RECORD KEY IS EMPRESAM WITH DUPLICATES
               FILE STATUS IS ESTADO1.

           SELECT PROVEDOR ASSIGN TO RANDOM "PROVEEDO.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS PROVE
               ALTERNATE RECORD KEY IS ENTERPRISE WITH DUPLICATES
               FILE STATUS IS ESTADO2.

           SELECT PLANTILLA ASSIGN TO RANDOM "PLANTILA.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS NOMBRE
               FILE STATUS IS ESTADO3.      

           SELECT SERVICIOS ASSIGN TO RANDOM "SERVICI.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC    
               RECORD KEY IS TARJETA
               ALTERNATE RECORD KEY IS OBJETO WITH DUPLICATES
               FILE STATUS IS ESTADO4.  

           SELECT IVA ASSIGN TO RANDOM "IVA.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC   
               RECORD KEY IS COD-IVA
               FILE STATUS IS ESTADO5.

           SELECT ALBARAN ASSIGN TO RANDOM "ALBARAN.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS ALB-NUM
               ALTERNATE RECORD KEY IS MES-ALB.

           SELECT FACTURADO ASSIGN TO RANDOM "FACTURA.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS FACT-NUM
               ALTERNATE RECORD KEY IS FECHAF.

           SELECT DIARIO ASSIGN TO RANDOM "DIARIO.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS NUM-FAC
               ALTERNATE RECORD KEY IS MES-D.

           SELECT FACTURAS ASSIGN TO RANDOM "RECIBO.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS REC-NUM
               ALTERNATE RECORD KEY IS MES-R.

           SELECT PAGO ASSIGN TO RANDOM "FORMAPAG.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC   
               RECORD KEY IS COD-PAGO
               FILE STATUS IS ESTADO6. 

           SELECT PEDIDO ASSIGN TO RANDOM "PEDIDO.DAT"
               ORGANIZATION IS INDEXED
               ACCESS MODE IS DYNAMIC
               RECORD KEY IS NUM. 
          
           SELECT IMPRESO ASSIGN TO PRINT "PRINTER".

       DATA DIVISION.
       FILE SECTION. 
        
       FD  MAESTRO, LABEL RECORD IS STANDARD.
       01  R-MAESTRO.
           02 CLIENTEM  PIC X(6).
           02 EMPRESAM  PIC X(30).
           02 LOCALIDADM PIC X(30).
           02 DIRECCIONM PIC X(30).
           02 TELEFONOM PIC Z99/9(7).
           02 C-POSTALM PIC X(6).
           02 CIFM      PIC X(11).       

       FD  PROVEDOR, LABEL RECORD IS STANDARD.
       01  R-PROVE.
           02 PROVE      PIC X(6).
           02 ENTERPRISE PIC X(30).
           02 LOCALIDADP PIC X(30).
           02 DIRECCIONP PIC X(30).
           02 TELEFONOP  PIC Z99/9(7).
           02 C-POSTALP  PIC X(6).
           02 CIFP        PIC X(11).

       FD  SERVICIOS, LABEL RECORD IS STANDARD
                      BLOCK CONTAINS 20 RECORDS. 
       01  R-SERV. 
           02 TARJETA     PIC 9(4).
           02 COD-OBJETO  PIC 9(2). 
           02 COD-SERV    PIC 9.
           02 COD-TRAT    PIC 9. 
           02 OBJETO      PIC X(30).
           02 SERVICIO    PIC X(30).
           02 TRATAMIENTO PIC X(30).
           02 COSTE       PIC 9(9).

       FD  IVA, LABEL RECORD IS STANDARD.
       01  R-IVA.
           02 COD-IVA     PIC 9.
           02 C-IVA       PIC 99.
           02 PORCENTAJE  PIC X.

       FD  PLANTILLA, LABEL RECORD IS STANDARD.
       01  R-TRAB.
           02 NOMBRE     PIC X(6).
           02 LOCALIDADT PIC X(30).
           02 DIRECCIONT PIC X(30).
           02 TELEFONOT  PIC Z99/9(7).
           02 C-POSTALT  PIC X.

       FD  PAGO, LABEL RECORD IS STANDARD.
       01  R-PAGO.
           02 COD-PAGO   PIC XX.     
           02 PLAZO      PIC X(30).
           02 INTERES    PIC 9(2).
           02 PORCEN-T   PIC X.

       FD  ALBARAN, LABEL RECORD IS STANDARD.
       01  R-ALBARAN.
           02 ALB-NUM  PIC X(6).
           02 COD-CLIA PIC X(6).
           02 DIA-ALB  PIC XX.      
           02 MES-ALB  PIC XX.
           02 INICIALBAR PIC X. 
           02 CANTIDAD PIC 9(10).
           02 CONCEPTO PIC X(30).
           02 SERVI-AL PIC X(30).
           02 TRATA-AL PIC X(30).
           02 IMPORTE  PIC 9(9).
           02 COD-IVALB  PIC X.
           02 BASE-IMPOA PIC 9(10). 
           02 TOTAL     PIC 9(12).
           02 EFEC-C    PIC 9(9).

       FD  FACTURADO, LABEL RECORD IS STANDARD.
       01  R-FACTURADO.
           02 FACT-NUM PIC X(6).
           02 COD-CLIF PIC X(6).
           02 FECHAF    PIC X(8).
           02 TOTAL-IMPORTE PIC 9(10).
           02 BASE-IMPOF PIC 9(10).
           02 IVA-REPER PIC 9(9).    

       FD  FACTURAS, LABEL RECORD IS STANDARD.
       01  R-RECIBO.
           02 REC-NUM PIC X(6).
           02 COBRADO PIC 9(9).
           02 COD-PRO PIC X(6).
           02 MES-R   PIC XX.        
           02 IVA-SOPOR PIC 9(9).
           02 EFE-P   PIC 9(9).

       FD  DIARIO, LABEL RECORD IS STANDARD.
       01  R-DIARIO.
           02 NUM-FAC PIC X(6).
           02 COD-CLID PIC X(6).
           02 ANO-D   PIC XX.      
           02 MES-D   PIC XX.      
           02 CLIENTE PIC 9(9).
           02 PROV-DI PIC 9(9).
           02 IVAR    PIC 9(9).
           02 IVAS    PIC 9(9).

       FD  PEDIDO, LABEL RECORD IS STANDARD.
       01  R-PEDIDO.
           02 NUM      PIC X(3).
           02 MES-P     PIC XX.
           02 DIA-P     PIC XX.
           02 CLIENTEP PIC X(6).
           02 OBJETOP  PIC X(30).
           02 SERVP    PIC X(30).
           02 TRATP    PIC X(30).
           02 COSTEP   PIC 9(9). 

       FD  IMPRESO, LABEL RECORD IS OMITTED.
       01  IMPRE        PIC X(80).

       WORKING-STORAGE SECTION.

       77  OPC-MENU     PIC X.
       77  RESP         PIC X.
       77  FIN          PIC X VALUE "N".
       77  AVANZAR      PIC X.
       77  CLIENTEW     PIC X(6).
       77  EXISTE       PIC X.
       77  EMPRESAW     PIC X(30).
       77  NUMERO       PIC X.
       77  CONTADOR6    PIC 9(9).
       77  CONTADOR7    PIC 9(9).
       77  CODIGOP      PIC X(6).
       77  TANTO        PIC 9(2).
       77  AVANCE       PIC X.

       01  CABECERA1.
           02 FILLER PIC X(30).
           02 FILLER PIC X(20) VALUE "LISTADO DE ALBARANES".

       01  CABECERA2.
           02 FILLER PIC X(29).
           02 FILLER PIC X(22) VALUE "LISTADO DE FACTURACION".  

       01  CABEC1.
           02 FILLER PIC X(56).
           02 FILLER PIC X(10) VALUE ALL "-".
           02 FILLER PIC X(2).
           02 FILLER PIC X(10) VALUE ALL "-".

       01  FEC.
           02 FILLER PIC X(56).
           02 AN-DE  PIC Z9/.
           02 MES-DE PIC Z9/.
           02 DIA-DE PIC Z9.
           02 FILLER PIC X(4).
           02 CLIENTE-DE PIC X(6).

       01  CABEC1-2.
           02 FILLER PIC X(80) VALUE ALL "-".

       01  FEC6.
           02 FILLER PIC X(10).
           02 FILLER PIC X(7) VALUE "EMPRESA".
           02 FILLER PIC X(33).
           02 FILLER PIC X VALUE "I".
           02 FILLER PIC X.
           02 FILLER PIC X(3) VALUE "CIF".

       01  CABEC1-3.
           02 FILLER PIC X(20).
           02 EMPRE-DE PIC X(30).
           02 FILLER PIC X VALUE "I".
           02 FILLER PIC X.
           02 CIF-DE PIC X(11).

       01  CABEC1-4.
           02 FILLER PIC X(10).
           02 FILLER PIC X(9) VALUE "DOMICILIO".
           02 FILLER PIC X(21).
           02 FILLER PIC X VALUE "I".
           02 FILLER PIC X.
           02 FILLER PIC X(8) VALUE "TELEFONO".  

       01  FEC1.    
           02 FILLER PIC X(10).
           02 DOMI-DE PIC X(30).
           02 FILLER PIC X VALUE "I".
           02 FILLER PIC X.
           02 TLF-DE PIC Z99/9(7).

       01  CABEC1-5.
           02 FILLER PIC X(10).
           02 FILLER PIC X(9) VALUE "CANTIDAD".
           02 FILLER PIC X(2).
           02 FILLER PIC X VALUE "I".
           02 FILLER PIC X.
           02 FILLER PIC X(8) VALUE "CONCEPTO". 
           02 FILLER PIC X(21).
           02 FILLER PIC X.
           02 FILLER PIC X(6) VALUE "PRECIO".
           02 FILLER PIC X(3).

       01  CABEC1-6.
           02 FILLER PIC X(10).
           02 FILLER PIC X(13) VALUE "TOTAL-IMPORTE".
           02 FILLER PIC X(5).
           02 FILLER PIC X(14) VALUE "BASE-IMPONIBLE".
           02 FILLER PIC X(5).
           02 FILLER PIC X(3) VALUE "IVA".

       01  FEC7.
           02 FILLER PIC X(12).
           02 IMPOR-DE PIC 9(9).
           02 FILLER PIC X(7).
           02 BIMPO-DE PIC 9(9).
           02 FILLER PIC X(5).
           02 IVA-DE PIC 9(2).  

       01  FEC2.
           02 FILLER PIC X(10).
           02 CANT-DE PIC 9(9).
           02 FILLER PIC X(2).
           02 FILLER PIC X VALUE "I".
           02 FILLER PIC X.
           02 OBJE-DE PIC X(30).
           02 FILLER PIC X.
           02 PRE-DE PIC 9(9).

       01  FEC3.
           02 FILLER PIC X(23).
           02 SERV-DT PIC X(30).

       01  FEC4.
           02 FILLER PIC X(23).
           02 TRAT-DT PIC X(30).

       01  CAB1-1-I.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"C9".
           02 FILLER PIC X(21) VALUE ALL X"CD".   
           02 FILLER PIC X VALUE X"BB".  

       01  CAB1-1-1.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".   
           02 FILLER PIC X(4). 
           02 FILLER PIC X(11) VALUE "PROVEEDORES".
           02 FILLER PIC X(6).
           02 FILLER PIC X VALUE X"BA".   

       01  CAB1-1-2.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".         
           02 FILLER PIC X(6). 
           02 FILLER PIC X(8) VALUE "CLIENTES".
           02 FILLER PIC X(9).
           02 FILLER PIC X VALUE X"BA".     

       01  CAB1-1-3.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".   
           02 FILLER PIC X(6).
           02 FILLER PIC X(9) VALUE "PLANTILLA".
           02 FILLER PIC X(8).
           02 FILLER PIC X VALUE X"BA".    

       01  CAB1-2.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".   
           02 FILLER PIC X(21) VALUE "LAVANDERIA GARBI-TOKI".
           02 FILLER PIC X VALUE X"BA".         

       01  SCAB1-2-1.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"CC". 
           02 FILLER PIC X(21) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"B9". 

       01  SCAB1-2-2.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X.
           02 FILLER PIC X(19) VALUE "Avda. Cervantes, 23".
           02 FILLER PIC X.
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-2-3.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X.
           02 FILLER PIC X(23) VALUE "Telfono:(94)4497110".
           02 FILLER PIC X.
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-2-4.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(3).
           02 FILLER PIC X(15) VALUE "48970 - BASAURI".
           02 FILLER PIC X(3).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-2-5.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(2).
           02 FILLER PIC X(18) VALUE "C.I.F. A/48-445399".
           02 FILLER PIC X.
           02 FILLER PIC X VALUE X"BA". 

       01  CUADRO1.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"C9".
           02 FILLER PIC X(24) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"BC".
           02 FILLER PIC X(21).
           02 FILLER PIC X VALUE X"C8".
           02 FILLER PIC X(23) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"BB".

       01  CUADRO2.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"C9".
           02 FILLER PIC X(70) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"BB".  

       01  CODIGO.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(15).
           02 FILLER PIC X(7) VALUE "NUMERO:".
           02 CLIENTE-DET PIC X(6).
           02 FILLER PIC X(43).
           02 FILLER PIC X VALUE X"BA".

       01  CAB1-3-1.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(7) VALUE "EMPRESA".
           02 FILLER PIC X(21).   
           02 FILLER PIC X(9) VALUE "LOCALIDAD".
           02 FILLER PIC X(16).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-3-1.
           02 FILLER PIC X(4). 
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(8) VALUE ALL X"CD".
           02 FILLER PIC X(21).
           02 FILLER PIC X(9) VALUE ALL X"CD".
           02 FILLER PIC X(15).
           02 FILLER PIC X VALUE X"BA".

       01  CAB1-3-2.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(6) VALUE "C.I.F.".
           02 FILLER PIC X(22).
           02 FILLER PIC X(9) VALUE "DIRECCION".
           02 FILLER PIC X(16).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-3-2.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(6) VALUE ALL X"CD".
           02 FILLER PIC X(22).
           02 FILLER PIC X(9) VALUE ALL X"CD".
           02 FILLER PIC X(16).
           02 FILLER PIC X VALUE X"BA".

       01  CAB1-3-3.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(13).
           02 FILLER PIC X(13) VALUE "CODIGO-POSTAL".
           02 FILLER PIC X(19).
           02 FILLER PIC X(8) VALUE "TELEFONO".
           02 FILLER PIC X(17).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-3-3.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(13).
           02 FILLER PIC X(13) VALUE ALL X"CD".
           02 FILLER PIC X(19).
           02 FILLER PIC X(8) VALUE ALL X"CD".
           02 FILLER PIC X(17).
           02 FILLER PIC X VALUE X"BA".

       01  LINE-DET1.
           02 FILLER       PIC X(4).
           02 FILLER       PIC X VALUE X"BA".
           02 FILLER       PIC X(3).
           02 EMPRESA-DE   PIC X(30).
           02 FILLER       PIC X(4).
           02 LOCALIDAD-DE PIC X(32).
           02 FILLER       PIC X.
           02 FILLER       PIC X VALUE X"BA".

       01  LINE-DET2.
           02 FILLER       PIC X(4).
           02 FILLER       PIC X VALUE X"BA".
           02 FILLER       PIC X(11).
           02 CIF-DET       PIC XXXXXXXXXXX.
           02 FILLER       PIC X(15).
           02 DIRECCION-DE PIC X(30).
           02 FILLER       PIC X(3).
           02 FILLER       PIC X VALUE X"BA".

       01  LINE-DET3.
           02 FILLER       PIC X(4).
           02 FILLER       PIC X VALUE X"BA".
           02 FILLER       PIC X(17).
           02 C-POSTAL-DE  PIC X(6).
           02 FILLER       PIC X(22).
           02 TELEFONO-DE  PIC Z99/9(7).
           02 FILLER       PIC X(14).
           02 FILLER       PIC X VALUE X"BA".

       01  FECHA.
           02 ANNO PIC 99.
           02 MES PIC 99.
           02 DIA PIC 99.

       01  CAB-FECHA.
           02 ANO-CA PIC Z9/.
           02 MES-CA PIC Z9/.
           02 DIA-CA PIC Z9.

       01  CUADRO.
           02 FILLER PIC X(80).

       01  CAB1-1-P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"C9".
           02 FILLER PIC X(21) VALUE ALL X"CD".   
           02 FILLER PIC X VALUE X"BB".

       01  RAYAS.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(70).
           02 FILLER PIC X VALUE X"BA".  

       01  CAB1-11P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".   
           02 FILLER PIC X(4). 
           02 FILLER PIC X(11) VALUE "PROVEEDORES".
           02 FILLER PIC X(6).
           02 FILLER PIC X VALUE X"BA".   

       01  CAB1-12P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".         
           02 FILLER PIC X(6). 
           02 FILLER PIC X(8) VALUE "CLIENTES".
           02 FILLER PIC X(7).
           02 FILLER PIC X VALUE X"BA".     

       01  CAB1-13P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".   
           02 FILLER PIC X(6).
           02 FILLER PIC X(9) VALUE "PLANTILLA".
           02 FILLER PIC X(6).
           02 FILLER PIC X VALUE X"BA".    

       01  CAB12P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".   
           02 FILLER PIC X(21) VALUE "LAVANDERIA GARBI-TOKI".
           02 FILLER PIC X VALUE X"BA".         

       01  SCAB1-21P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"CC". 
           02 FILLER PIC X(21) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"B9". 

       01  SCAB1-22P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X.
           02 FILLER PIC X(19) VALUE "Avda. Cervantes, 23".
           02 FILLER PIC X.
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-23P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(3) VALUE "Tel".                 
           02 FILLER PIC X VALUE X"8A".
           02 FILLER PIC X(19) VALUE "fono:(94)4497110".

       01  S23PBIS.
           02 FILLER PIC X VALUE X"BA". 

       01  SCAB1-24P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(3).
           02 FILLER PIC X(15) VALUE "48970 - BASAURI".
           02 FILLER PIC X(3).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-25P.
           02 FILLER PIC X(29).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(2).
           02 FILLER PIC X(18) VALUE "C.I.F. A/48-445399".
           02 FILLER PIC X.
           02 FILLER PIC X VALUE X"BA". 

       01  CUADR1P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"C9".
           02 FILLER PIC X(24) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"CA".
           02 FILLER PIC X(21) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"CA".
           02 FILLER PIC X(23) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"BB".

       01  CUADR2P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"C8".
           02 FILLER PIC X(70) VALUE ALL X"CD".
           02 FILLER PIC X VALUE X"BC".  

       01  CODIGP.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".          
           02 FILLER PIC X(15).
           02 FILLER PIC X(9) VALUE "1>NUMERO:".
           02 CLIENTE-DEP PIC 9(6).
           02 FILLER PIC X(40).
           02 FILLER PIC X VALUE X"BA".

       01  CAB1-31P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(9) VALUE "2>EMPRESA".
           02 FILLER PIC X(19).   
           02 FILLER PIC X(11) VALUE "3>LOCALIDAD".
           02 FILLER PIC X(14).
           02 FILLER PIC X VALUE X"BA".

       01  CAB131P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(11) VALUE "2>DIRECCION".
           02 FILLER PIC X(17).   
           02 FILLER PIC X(11) VALUE "3>LOCALIDAD".
           02 FILLER PIC X(14).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB131P.
           02 FILLER PIC X(4). 
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(11) VALUE ALL X"CD".
           02 FILLER PIC X(17).
           02 FILLER PIC X(11) VALUE ALL X"CD".
           02 FILLER PIC X(14).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-31P.
           02 FILLER PIC X(4). 
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(9) VALUE ALL X"CD".
           02 FILLER PIC X(19).
           02 FILLER PIC X(11) VALUE ALL X"CD".
           02 FILLER PIC X(14).
           02 FILLER PIC X VALUE X"BA".

       01  CAB1-32P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(8) VALUE "4>C.I.F.".
           02 FILLER PIC X(20).
           02 FILLER PIC X(11) VALUE "5>DIRECCION".
           02 FILLER PIC X(14).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-32P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(17).
           02 FILLER PIC X(8) VALUE ALL X"CD".
           02 FILLER PIC X(20).
           02 FILLER PIC X(11) VALUE ALL X"CD".
           02 FILLER PIC X(14).
           02 FILLER PIC X VALUE X"BA".

       01  CAB1-33P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(13).
           02 FILLER PIC X(15) VALUE "6>CODIGO-POSTAL".
           02 FILLER PIC X(17).
           02 FILLER PIC X(10) VALUE "7>TELEFONO".
           02 FILLER PIC X(15).
           02 FILLER PIC X VALUE X"BA".

       01  CAB1-33PBIS.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(13).
           02 FILLER PIC X(15) VALUE "4>CODIGO-POSTAL".
           02 FILLER PIC X(17).
           02 FILLER PIC X(10) VALUE "5>TELEFONO".
           02 FILLER PIC X(15).
           02 FILLER PIC X VALUE X"BA".

       01  SCAB1-33P.
           02 FILLER PIC X(4).
           02 FILLER PIC X VALUE X"BA".
           02 FILLER PIC X(13).
           02 FILLER PIC X(15) VALUE ALL X"CD".
           02 FILLER PIC X(17).
           02 FILLER PIC X(10) VALUE ALL X"CD".
           02 FILLER PIC X(15).
           02 FILLER PIC X VALUE X"BA".

       01  LINE-DE1P.
           02 FILLER       PIC X(4).
           02 FILLER       PIC X VALUE X"BA".
           02 FILLER       PIC X(3).
           02 EMPRESA-DP   PIC X(30).
           02 FILLER       PIC X(4).
           02 LOCALIDAD-DP PIC X(32).
           02 FILLER       PIC X.
           02 FILLER       PIC X VALUE X"BA".

       01  LINE-DE2P.
           02 FILLER       PIC X(4).
           02 FILLER       PIC X VALUE X"BA".
           02 FILLER       PIC X(11).
           02 CIF-DEP       PIC XXXXXXXXXXX.
           02 FILLER       PIC X(15).
           02 DIRECCION-DP PIC X(30).
           02 FILLER       PIC X(3).
           02 FILLER       PIC X VALUE X"BA".

       01  LINEDE1P.
           02 FILLER       PIC X(4).
           02 FILLER       PIC X VALUE X"BA".
           02 FILLER       PIC X(3).
           02 DIRECCION-D  PIC X(30).
           02 FILLER       PIC X(4).
           02 LOCALIDAD-D  PIC X(32).
           02 FILLER       PIC X.
           02 FILLER       PIC X VALUE X"BA".

       01  LINE-DE3P.
           02 FILLER       PIC X(4).
           02 FILLER       PIC X VALUE X"BA".
           02 FILLER       PIC X(17).
           02 C-POSTAL-DP  PIC X(6).
           02 FILLER       PIC X(22).
           02 TELEFONO-DP  PIC Z99/9(7).
           02 FILLER       PIC X(14).
           02 FILLER       PIC X VALUE X"BA".

       01  FECP.
           02 ANNP PIC 99.
           02 MEP PIC 99.
           02 DIP PIC 99.

       01  CAB-FECP.
           02 FILLER PIC X(70).
           02 DIA-CP PIC Z9/.
           02 MES-CP PIC Z9/.  
           02 ANO-CP PIC Z9.

       77  TIPO         PIC X.
       77  INICIAL      PIC X.  
       77  A            PIC 99.
       77  B            PIC 9.
       77  C            PIC 9.
       77  A-1          PIC 99.
       77  B-1          PIC 9.
       77  C-1          PIC 9.
       77  CODIGO-TW    PIC 9(4).
       77  OBJETO-W     PIC X(30).
       77  SERV-W       PIC X(30).
       77  TRAT-W       PIC X(30).
       77  COSTE-W      PIC 9(9).
       77  FORMA        PIC X.
       77  CONTADOR     PIC 9(3) VALUE ZERO.
       77  CONTADOR1    PIC 9(9) VALUE ZERO.
       77  CONTADOR2    PIC 9(9) VALUE ZERO.
       77  CONTADOR3    PIC 9(9) VALUE ZERO.
       77  CONTADOR4    PIC 9(9) VALUE ZERO.
       77  CONTADOR5    PIC 9(9) VALUE ZERO.

       01  SERVI.
           02 TAB-OBJ OCCURS 20.
               03 OBJETO-D PIC X(30).
               03 TAB-SERV OCCURS 5. 
                   04 SERV-D PIC X(30).
                   04 TAB-TRAT OCCURS 4.
                       05 TRAT-D PIC X(30).
                       05 COSTE-D PIC 9(9).

       01  CAB-TAB1.
           02 FILLER PIC X(31).
           02 FILLER PIC X(17) VALUE "LISTADO DE COSTES".

       01  TAB1-1.
           02 FILLER PIC X(8).
           02 OBJETO-DE PIC X(30).
           02 FILLER PIC X(4).
           02 SERV-DE PIC X(30).

       01  TAB1-2.
           02 FILLER PIC X(20).
           02 TRAT-DE PIC X(30).
           02 FILLER PIC X(4).
           02 COSTE-DE PIC 9(9).

       77  ESTADO1      PIC XX.
       77  ESTADO2      PIC XX.
       77  ESTADO3      PIC XX.
       77  ESTADO4      PIC XX.
       77  ESTADO5      PIC XX. 
       77  ESTADO6      PIC XX. 
       77  I            PIC 99. 
       77  IVA-W        PIC 99.
       77  PORC-W       PIC X.
       77  INTE-W       PIC 99.
       77  TARJETW      PIC 9(4).
       77  EXCEP        PIC 99.
       77  EXCET        PIC 9.

       01  IMP.
           02 TAB-IVA OCCURS 3.
               03 IVA-D PIC 99.
               03 PORCEN-D PIC XX.

       01  FORMAP.
           02 TAB-PAGO OCCURS 10.
               03 PLAZO-D PIC X(30).
               03 INTE-D PIC 99. 
               03 PORCENT PIC X.

       PROCEDURE DIVISION.

       DECLARATIVES.
       INPUT-ERROR SECTION 1.
           USE AFTER STANDARD ERROR PROCEDURE ON INPUT.

       PROCE1.
           IF ESTADO1 = "00"
              DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE
              PERFORM CREACIONC.
           IF ESTADO2 = "00"
              DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE
              PERFORM CREACIONP.
           IF ESTADO3 = "00"
              DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE
              PERFORM CREACIONT.
           IF ESTADO4 = "00"
              DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE 
              PERFORM INICIALIZAR1.
           IF ESTADO5 = "00"
              DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE
              PERFORM INICIALIZAR2.
           IF ESTADO6 = "00"
              DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE
              PERFORM INICIALIZAR3. 
           IF ESTADO1 = "00"
              AND ESTADO2 = "00"
              AND ESTADO3 = "00"
              AND ESTADO4 = "00"
              AND ESTADO5 = "00"
              AND ESTADO6 = "00"
              PERFORM APERTURA. 
               
       CREACIONC.
           OPEN OUTPUT MAESTRO 
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           PERFORM PANT1 
           ACCEPT CLIENTE-DET LINE 10 POSITION 30
           MOVE CLIENTE-DET TO CLIENTEM
           PERFORM PROCESOC UNTIL CLIENTEM = "*"
           CLOSE MAESTRO.      

       PROCESOC.
           ACCEPT EMPRESA-DE LINE 14 POSITION 9  
           ACCEPT LOCALIDAD-DE LINE 14 POSITION 43
           ACCEPT CIF-DE LINE 17 POSITION 17 
           ACCEPT DIRECCION-DE LINE 17 POSITION 45 
           ACCEPT C-POSTAL-DE LINE 20 POSITION 23
           ACCEPT TELEFONO-DE LINE 20 POSITION 51
           MOVE EMPRESA-DP TO EMPRESAM
           MOVE LOCALIDAD-DP TO LOCALIDADM 
           MOVE DIRECCION-DP TO DIRECCIONM
           MOVE TELEFONO-DP TO TELEFONOM
           MOVE C-POSTAL-DP TO C-POSTALM
           MOVE CIF-DEP TO CIFM
           DISPLAY "SI ESTA BIEN PULSE S"
                    LINE 23 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,4,,, SEGUN EL CAMPO"
                    LINE 24 POSITION 10
           ACCEPT NUMERO, LINE 25 POSITION 52
           PERFORM VALIDARC UNTIL NUMERO = "S" OR NUMERO = "s"
           WRITE R-MAESTRO
           DISPLAY " ", ERASE
           PERFORM PANT1
           PERFORM INTRO-CLIENTEW.               

       PANT1.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ACCEPT FECP FROM DATE
           MOVE ANNP TO ANO-CP
           MOVE MEP TO MES-CP
           MOVE DIP TO DIA-CP
           DISPLAY CAB-FECP  LINE 1                    
           DISPLAY CAB1-1-P  LINE 1  
           DISPLAY CAB1-12P  LINE 2            
           DISPLAY CAB12P    LINE 3
           DISPLAY SCAB1-21P LINE 4             
           DISPLAY SCAB1-22P LINE 5
           DISPLAY SCAB1-23P LINE 6
           DISPLAY S23PBIS   LINE 6 POSITION 52
           DISPLAY SCAB1-24P LINE 7 
           DISPLAY SCAB1-25P LINE 8 
           DISPLAY CUADR1P  LINE  9            
           DISPLAY CODIGP LINE 10
           DISPLAY RAYAS  LINE 11
           DISPLAY CAB1-31P LINE 12 
           DISPLAY SCAB1-31P LINE 13
           DISPLAY LINE-DE1P LINE 14
           DISPLAY CAB1-32P LINE 15
           DISPLAY SCAB1-32P LINE 16
           DISPLAY LINE-DE2P LINE 17
           DISPLAY CAB1-33P LINE 18
           DISPLAY SCAB1-33P LINE 19
           DISPLAY LINE-DE3P LINE 20
           DISPLAY CUADR2P LINE 21.

       VALIDARC.
           IF NUMERO = "1"
             PERFORM INTRO-CLIENTEW
           ELSE 
             IF NUMERO = "2"
               PERFORM INTRO-EMPRESAC
             ELSE
               IF NUMERO = "3"
                 PERFORM INTRO-LOCALIDADC
               ELSE
                 IF NUMERO = "4"
                   PERFORM INTRO-CIFC
                 ELSE
                   IF NUMERO = "5"
                     PERFORM INTRO-DIRECCIONC
                   ELSE
                     IF NUMERO = "6"
                       PERFORM INTRO-CPOSTALC
                     ELSE
                       IF NUMERO = "7"
                         PERFORM INTRO-TELEFONOC
                       ELSE
                         DISPLAY "OPCION ERRONEA, REPITA"
                                 LINE 24 POSITION 30.
           DISPLAY "SI ESTA BIEN PULSE S"
                   LINE 23 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,,, SEGUN EL CAMPO"
                   LINE 24 POSITION 10
           ACCEPT NUMERO, LINE 25 POSITION 52.   

       INTRO-EMPRESAC.
           ACCEPT EMPRESAM, LINE 14 POSITION 9.

       INTRO-LOCALIDADC.
           ACCEPT LOCALIDADM, LINE 14 POSITION 43.

       INTRO-DIRECCIONC.
           ACCEPT DIRECCIONM, LINE 17 POSITION 45.

       INTRO-TELEFONOC.
           ACCEPT TELEFONOM, LINE 17 POSITION 17.

       INTRO-CPOSTALC.
           ACCEPT C-POSTALM, LINE 20 POSITION 51.

       INTRO-CIFC.
           ACCEPT CIFM, LINE 20 POSITION 23. 

       INTRO-CLIENTEW.
           ACCEPT CLIENTEM, LINE 10 POSITION 30. 

       CREACIONP.
           OPEN OUTPUT PROVEDOR
           PERFORM PANT2
           ACCEPT CLIENTE-DET LINE 10 POSITION 30
           MOVE CLIENTE-DET TO PROVE
           PERFORM PROCESO UNTIL PROVE = "*"
           CLOSE PROVEDOR.

       PROCESO.
           ACCEPT EMPRESA-DE LINE 14 POSITION 9  
           ACCEPT LOCALIDAD-DE LINE 14 POSITION 43
           ACCEPT CIF-DE LINE 17 POSITION 17 
           ACCEPT DIRECCION-DE LINE 17 POSITION 45 
           ACCEPT C-POSTAL-DE LINE 20 POSITION 23
           ACCEPT TELEFONO-DE LINE 20 POSITION 51
           MOVE EMPRESA-DP TO ENTERPRISE
           MOVE LOCALIDAD-DP TO LOCALIDADP 
           MOVE DIRECCION-DP TO DIRECCIONP
           MOVE TELEFONO-DP TO TELEFONOP
           MOVE C-POSTAL-DP TO C-POSTALP
           MOVE CIF-DEP TO CIFP
           DISPLAY "SI ESTA BIEN PULSE S"
                    LINE 23 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,4,,, SEGUN EL CAMPO"
                    LINE 24 POSITION 10
           ACCEPT NUMERO, LINE 25 POSITION 52
           PERFORM VALIDARP UNTIL NUMERO = "S" OR NUMERO = "s"
           WRITE R-PROVE.
           DISPLAY " ", ERASE
           PERFORM PANT2
           PERFORM INTRO-PROVEW.                 

       PANT2.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ACCEPT FECP FROM DATE
           MOVE ANNP TO ANO-CP
           MOVE MEP TO MES-CP
           MOVE DIP TO DIA-CP
           DISPLAY CAB-FECP  LINE 1                    
           DISPLAY CAB1-1-P  LINE 1  
           DISPLAY CAB1-11P  LINE 2            
           DISPLAY CAB12P    LINE 3
           DISPLAY SCAB1-21P LINE 4             
           DISPLAY SCAB1-22P LINE 5
           DISPLAY SCAB1-23P LINE 6
           DISPLAY S23PBIS   LINE 6 POSITION 52
           DISPLAY SCAB1-24P LINE 7 
           DISPLAY SCAB1-25P LINE 8 
           DISPLAY CUADR1P  LINE  9            
           DISPLAY CODIGP LINE 10
           DISPLAY RAYAS  LINE 11
           DISPLAY CAB1-31P LINE 12 
           DISPLAY SCAB1-31P LINE 13
           DISPLAY LINE-DE1P LINE 14
           DISPLAY CAB1-32P LINE 15
           DISPLAY SCAB1-32P LINE 16
           DISPLAY LINE-DE2P LINE 17
           DISPLAY CAB1-33P LINE 18
           DISPLAY SCAB1-33P LINE 19
           DISPLAY LINE-DE3P LINE 20
           DISPLAY CUADR2P LINE 21.

       VALIDARP.
           IF NUMERO = "1"
             PERFORM INTRO-PROVEW
           ELSE 
             IF NUMERO = "2"
               PERFORM INTRO-EMPRESAP
             ELSE
               IF NUMERO = "3"
                 PERFORM INTRO-LOCALIDADP
               ELSE
                 IF NUMERO = "4"
                   PERFORM INTRO-CIFP
                 ELSE
                   IF NUMERO = "5"
                     PERFORM INTRO-DIRECCIONP
                   ELSE
                     IF NUMERO = "6"
                       PERFORM INTRO-CPOSTALP
                     ELSE
                       IF NUMERO = "7"
                         PERFORM INTRO-TELEFONOP
                       ELSE
                         DISPLAY "OPCION ERRONEA, REPITA"
                                 LINE 24 POSITION 30.
           DISPLAY "SI ESTA BIEN PULSE S"
                   LINE 23 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,,, SEGUN EL CAMPO"
                   LINE 24 POSITION 10
           ACCEPT NUMERO, LINE 25 POSITION 52.   

       INTRO-EMPRESAP.
           ACCEPT ENTERPRISE LINE 14 POSITION 9.

       INTRO-LOCALIDADP.
           ACCEPT LOCALIDADP LINE 14 POSITION 43.

       INTRO-DIRECCIONP.
           ACCEPT DIRECCIONP  LINE 17 POSITION 45.

       INTRO-TELEFONOP.
           ACCEPT TELEFONOP  LINE 17 POSITION 17.

       INTRO-CPOSTALP.
           ACCEPT C-POSTALP  LINE 20 POSITION 51.

       INTRO-CIFP.
           ACCEPT CIFP  LINE 20 POSITION 23. 

       INTRO-PROVEW.
           ACCEPT PROVE LINE 10 POSITION 30. 

       CREACIONT.
           OPEN OUTPUT PLANTILLA
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"                        
           PERFORM PANT3
           ACCEPT CLIENTE-DET LINE 10 POSITION 30
           MOVE CLIENTE-DET TO NOMBRE           
           PERFORM PROCESOT UNTIL NOMBRE = "*"
           CLOSE PLANTILLA.      

       PROCESOT.
           ACCEPT LOCALIDAD-D LINE 14 POSITION 43
           ACCEPT DIRECCION-D LINE 14 POSITION 9  
           ACCEPT C-POSTAL-DP LINE 17 POSITION 23
           ACCEPT TELEFONO-DP LINE 17 POSITION 51
           MOVE LOCALIDAD-D TO LOCALIDADT 
           MOVE DIRECCION-D TO DIRECCIONT
           MOVE TELEFONO-DP TO TELEFONOT
           MOVE C-POSTAL-DP TO C-POSTALT
           DISPLAY "SI ESTA BIEN PULSE S"
                    LINE 23 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,4,,, SEGUN EL CAMPO"
                    LINE 24 POSITION 10
           ACCEPT NUMERO, LINE 25 POSITION 52
           PERFORM VALIDART UNTIL NUMERO = "S" OR NUMERO = "s"
           WRITE R-TRAB.
           DISPLAY " ", ERASE
           PERFORM PANT3
           PERFORM INTRO-CLIENTEWT.

       PANT3.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ACCEPT FECP FROM DATE
           MOVE ANNP TO ANO-CP
           MOVE MEP TO MES-CP
           MOVE DIP TO DIA-CP
           DISPLAY CAB-FECP  LINE 1                    
           DISPLAY CAB1-1-P  LINE 1  
           DISPLAY CAB1-13P  LINE 2            
           DISPLAY CAB12P    LINE 3
           DISPLAY SCAB1-21P LINE 4             
           DISPLAY SCAB1-22P LINE 5
           DISPLAY SCAB1-23P LINE 6
           DISPLAY S23PBIS   LINE 6 POSITION 52
           DISPLAY SCAB1-24P LINE 7 
           DISPLAY SCAB1-25P LINE 8 
           DISPLAY CUADR1P  LINE  9            
           DISPLAY CODIGP LINE 10
           DISPLAY RAYAS  LINE 11
           DISPLAY CAB1-31P LINE 12 
           DISPLAY SCAB1-31P LINE 13
           DISPLAY LINEDE1P LINE 14
           DISPLAY CAB1-33PBIS LINE 15
           DISPLAY SCAB1-33P LINE 16
           DISPLAY LINE-DE3P LINE 17
           DISPLAY CUADR2P LINE 18.

       VALIDART.
           IF NUMERO = "1"
             PERFORM INTRO-CLIENTEWT 
           ELSE 
             IF NUMERO = "2"
                 PERFORM INTRO-LOCALIDADT
               ELSE
                   IF NUMERO = "3"
                     PERFORM INTRO-DIRECCIONT
                   ELSE
                     IF NUMERO = "4"
                       PERFORM INTRO-CPOSTALT
                     ELSE
                       IF NUMERO = "5"
                         PERFORM INTRO-TELEFONOT
                       ELSE
                         DISPLAY "OPCION ERRONEA, REPITA"
                                 LINE 24 POSITION 30.
           DISPLAY "SI ESTA BIEN PULSE S"
                   LINE 23 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,,, SEGUN EL CAMPO"
                   LINE 24 POSITION 10
           ACCEPT NUMERO, LINE 25 POSITION 52.   

       INTRO-LOCALIDADT.
           ACCEPT LOCALIDADT, LINE 14 POSITION 43.

       INTRO-DIRECCIONT.
           ACCEPT DIRECCIONT, LINE 14 POSITION 9.

       INTRO-TELEFONOT.
           ACCEPT TELEFONOT, LINE 17 POSITION 51.

       INTRO-CPOSTALT.
           ACCEPT C-POSTALT, LINE 17 POSITION 23.

       INTRO-CLIENTEWT.
           ACCEPT NOMBRE, LINE 10 POSITION 30. 

       INICIALIZAR1.
           OPEN OUTPUT SERVICIOS
           PERFORM ICE
           CLOSE SERVICIOS.

       ICE.
           MOVE 99 TO COD-OBJETO
           MOVE 9 TO COD-SERV
           MOVE 9 TO COD-TRAT
           MOVE "AAAA" TO OBJETO
           MOVE SPACE TO SERVICIO
           MOVE SPACE TO TRATAMIENTO
           MOVE ZEROS TO COSTE
           MOVE 9999 TO TARJETA
           WRITE R-SERV.

       INICIALIZAR2.
           OPEN OUTPUT IVA
           MOVE 1 TO I
           PERFORM INICI2 UNTIL I = 4
           CLOSE IVA.

       INICI2.
           MOVE ZEROS TO IVA-D(I)
           MOVE "%" TO PORCEN-D(I)
           MOVE I TO COD-IVA
           MOVE IVA-D(I) TO C-IVA
           MOVE PORCEN-D(I) TO PORCENTAJE
           WRITE R-IVA.
           ADD 1 TO I.

       INICIALIZAR3.
           OPEN OUTPUT PAGO
           PERFORM INICI3 VARYING I FROM 1 BY 1 UNTIL I > 10
           CLOSE PAGO.

       INICI3.
           MOVE "PLAZO" TO PLAZO-D(I)
           MOVE ZEROS TO INTE-D(I)
           MOVE PORC-W TO PORCENT(I)
           MOVE I TO COD-PAGO
           MOVE PLAZO-D(I) TO PLAZO
           MOVE ZEROS TO INTERES
           MOVE PORCENT(I) TO  PORCEN-T
           WRITE R-PAGO.  
       END DECLARATIVES.

       PRINCIPAL SECTION 2.

       APERTURA.
           OPEN INPUT MAESTRO, PROVEDOR, PLANTILLA
                      SERVICIOS, IVA, PAGO
           CLOSE MAESTRO, PROVEDOR, PLANTILLA, SERVICIOS, IVA, PAGO
           PERFORM PROCEDIMIENTO-PRINCIPAL  
           STOP RUN.

       PROCEDIMIENTO-PRINCIPAL.
           PERFORM MENU-PRINCIPAL UNTIL TIPO = "4". 

       MENU-PRINCIPAL.

           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                   "
             LINE 5 POSITION 29 SIZE 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 6 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "  GARBI-TOKI s.a."
                    LINE 6 POSITION 30 REVERSE
           DISPLAY " " LINE 6 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "                   "
                   LINE 7 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "                                     "
           LINE 8 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY "1.->MANTENIMIENTO DE LOS FICHEROS:"
                 LINE 9 POSITION 20 CONTROL "FCOLOR = GREEN"
           DISPLAY "   " LINE 9 POSITION 53
           DISPLAY "                                     "
                 LINE 10 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 11 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY "2.->EXPEDICION DE ALVARANAJE:"
                   LINE 11 POSITION 20 CONTROL "FCOLOR = GREEN"
           DISPLAY "        "
               LINE 11 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY "                                     "
                 LINE 12 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY "3.->FACTURACION Y CONTABILIDAD:"
                   LINE 13 POSITION 20 CONTROL "FCOLOR = GREEN"
           DISPLAY "      "
                 LINE 13 POSITION 50 CONTROL "BCOLOR = READ"
           DISPLAY "                                     "
                   LINE 14 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "4.-> FINALIZADO :"
                   LINE 15 POSITION 28 REVERSE
           DISPLAY " " LINE 15 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 16 POSITION 28 CONTROL "BCOLOR = READ" 
           ACCEPT TIPO, LINE 17 POSITION 38 BLINK
           PERFORM A-MENU.

       A-MENU.                
           IF TIPO = "1"
             PERFORM MANTENIMIENTO            
           ELSE
           IF TIPO = "2"
             PERFORM FACTURACION              
           ELSE
           IF TIPO = "3"
             PERFORM GESTION
           ELSE
           IF TIPO = "4"
             DISPLAY "FIN EJECUCION", ERASE
             LINE 14 POSITION 20 CONTROL "BCOLOR = BLUE" REVERSE
           ELSE  
             DISPLAY "ERROR", ERASE
             LINE 14 POSITION 20 CONTROL "BCOLOR = BLUE" REVERSE.

       MANTENIMIENTO.
           MOVE SPACE TO TIPO
           PERFORM MENU-MAESTRO UNTIL TIPO = "7". 

       MENU-MAESTRO.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                   "
             LINE 5 POSITION 29 SIZE 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 6 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "FICHEROS MAESTROS"
                    LINE 6 POSITION 30 REVERSE
           DISPLAY " " LINE 6 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "                   "
                   LINE 7 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "                                     "
           LINE 8 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY "1.->CLIENTES:      2.->PROVEEDORES:"
                 LINE 9 POSITION 20 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 9 POSITION 55
           DISPLAY "                                     "
                 LINE 10 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 11 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY "3.->SERVICIOS:     4.->PLANTILLA:"
                   LINE 11 POSITION 20 CONTROL "FCOLOR = GREEN"
           DISPLAY "   " LINE 11 POSITION 53 CONTROL "BCOLOR = READ"
           DISPLAY "                                     "
                 LINE 12 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY "5.->TIPOS DE IVA:  6.- FORMAS-PAGO:"
                   LINE 13 POSITION 20 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 13 POSITION 55 CONTROL "BCOLOR = READ"
           DISPLAY "                                     "
                   LINE 14 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "7.- RETORNO MENU:"
                   LINE 15 POSITION 28 REVERSE
           DISPLAY " " LINE 15 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 16 POSITION 28 CONTROL "BCOLOR = READ" 
           MOVE SPACE TO TIPO
           ACCEPT TIPO, LINE 17 POSITION 38 BLINK
           PERFORM A-TIPO.

       A-TIPO.                
           IF TIPO = "1"
             PERFORM CLIENTELA.        
           IF TIPO = "2"
             PERFORM PROVEDORES.    
           IF TIPO = "3"
             PERFORM SERV-TRAB.         
           IF TIPO = "4"
             PERFORM TRABAJADORES. 
           IF TIPO = "5"
             PERFORM IVA-T. 
           IF TIPO = "6"
             PERFORM PAGO-T.

       CLIENTELA.
           MOVE ZEROS TO OPC-MENU
           PERFORM P-MENUC UNTIL OPC-MENU = "7"
           DISPLAY " " ERASE
           DISPLAY "FIN EJECUCION" LINE 15 POSITION 20.

       PANTALLA2.
           DISPLAY " ", SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "1.-ALTAS:"
              LINE 18 POSITION 21  CONTROL "FCOLOR = BROWN"
           DISPLAY "2.-BAJAS:"
              LINE 19 POSITION 21  CONTROL "FCOLOR = BROWN"
           DISPLAY "3.-CONSULTA POR COD:"
              LINE 18 POSITION 32  CONTROL "FCOLOR = BROWN"
           DISPLAY "4.-CONSULTA POR EMP:"
              LINE 19 POSITION 32  CONTROL "FCOLOR = BROWN"
           DISPLAY "5.-MODIF:"
              LINE 20 POSITION 22  CONTROL "FCOLOR = BROWN"
           DISPLAY "6.-LISTADO:"
              LINE 20 POSITION 32  CONTROL "FCOLOR = BROWN"
           DISPLAY "7.-RETORNO:"
              LINE 21 POSITION 27  CONTROL "FCOLOR = BROWN"
           DISPLAY "ELIGA OPCION: "
              LINE 23 POSITION 22 REVERSE BLINK
           ACCEPT OPC-MENU LINE 23 POSITION 36 REVERSE BLINK.

       P-MENUC.
           PERFORM PANTALLA2 
           PERFORM VALIDAR-OPC UNTIL OPC-MENU > "0" AND OPC-MENU < "8"
           IF OPC-MENU = "1"
             PERFORM ALTASC
           ELSE
             IF OPC-MENU = "2"
               PERFORM BAJASC
             ELSE
               IF OPC-MENU = "3"
                 PERFORM CONS-CODC
               ELSE
                 IF OPC-MENU = "4"
                   PERFORM CONS-DESC
                 ELSE
                   IF OPC-MENU = "5"
                     PERFORM MODIFICACIONESC
                   ELSE
                     IF OPC-MENU = "6"
                       PERFORM MENU-LISTADOC UNTIL OPC-MENU = "3"
                   ELSE
                     IF OPC-MENU = "7"
                     DISPLAY " ", ERASE 
                     ELSE
                     PERFORM VALIDAR-OPC.                                      

       VALIDAR-OPC.  
           DISPLAY "OPCION ERRONEA. TECLEE DE NUEVO" LINE 25 POSITION 20
           ACCEPT OPC-MENU LINE 24 POSITION 35.

       VALIDARC.
           IF NUMERO = "1"
             PERFORM INTRO-CLIENTEW
           ELSE 
             IF NUMERO = "2"
               PERFORM INTRO-EMPRESAC
             ELSE
               IF NUMERO = "3"
                 PERFORM INTRO-LOCALIDADC
               ELSE
                 IF NUMERO = "4"
                   PERFORM INTRO-DIRECCIONC
                 ELSE
                   IF NUMERO = "5"
                     PERFORM INTRO-TELEFONOC
                   ELSE
                     IF NUMERO = "6"
                       PERFORM INTRO-CPOSTALC
                     ELSE
                       IF NUMERO = "7"
                         PERFORM INTRO-CIFC
                       ELSE
                         DISPLAY "OPCION ERRONEA, REPITA"
                                 LINE 24 POSITION 30.
           DISPLAY "SI ESTA BIEN PULSE S"
                   LINE 21 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,,, SEGUN EL CAMPO"
                   LINE 22 POSITION 10
           ACCEPT NUMERO, LINE 22 POSITION 52. 

       MENU-LISTADOC.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                   LINE 16 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "MENU DE LISTADO"
                   LINE 17 POSITION 34 REVERSE
           DISPLAY " " LINE 17 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 18 POSITION 33 CONTROL "BCOLOR = READ"  
           DISPLAY "   " LINE 19 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "1.>IMPRESORA"
                   LINE 19 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "  "
                   LINE 19 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 20 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "2.>PANTALLA"
                   LINE 20 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "   "
                   LINE 20 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 21 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "3.>RETORNO"
                   LINE 21 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "    "
                   LINE 21 POSITION 46 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 22 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " OPCION?:"
                   LINE 22 POSITION 36 REVERSE
           DISPLAY "   "
                   LINE 22 POSITION 47 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 22 POSITION 46 CONTROL "FCOLOR = READ"
           DISPLAY "                 "
                   LINE 23 POSITION 33 CONTROL "BCOLOR = BLUE"
           IF OPC-MENU = "1"
             PERFORM LISTADOC
           ELSE
             IF OPC-MENU = "2"
               OPEN INPUT MAESTRO
               MOVE LOW-VALUE TO CLIENTE
               PERFORM LEER-SEC-MAEC
               MOVE "N" TO FIN
               PERFORM PROCES-VISC UNTIL FIN = "S"
               CLOSE MAESTRO
             ELSE
               IF OPC-MENU = "3"
                 DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
               ELSE
                 DISPLAY "ERROR", ERASE
                  LINE 12 POSITION 20 SIZE 80 CONTROL "BCOLOR = BLUE".
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE".    

       PROCES-VISC.
             PERFORM VISU-PROC
             ACCEPT AVANZAR
             PERFORM LEER-SEC-MAEC.  

       LISTADOC.
           OPEN INPUT MAESTRO
                OUTPUT IMPRESO
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**LISTADO DE CLIENTES**"
                   LINE 2 POSITION 20, REVERSE
           DISPLAY " "
           DISPLAY "PREPARE LA IMPRESORA Y PULSE UNA TECLA"
                   LINE 8 POSITION 15
           ACCEPT AVANZAR LINE 8 POSITION 50
           PERFORM CABECERASC
           MOVE "N" TO FIN
           PERFORM LEER-SEC-MAEC
           PERFORM BUCLE-LISTADOC UNTIL FIN = "S"
           DISPLAY "*FIN DE LISTADO*"
                   LINE 15 POSITION 25, BLINK
           CLOSE MAESTRO, IMPRESO.

       CABECERASC.
           ACCEPT FECHA FROM DATE
           MOVE ANNO TO ANO-CA
           MOVE MES TO MES-CA
           MOVE DIA TO DIA-CA
           WRITE IMPRE FROM CAB-FECHA AFTER ADVANCING PAGE
           WRITE IMPRE FROM CAB1-1-I AFTER 4 LINES
           WRITE IMPRE FROM CAB1-1-2 
           WRITE IMPRE FROM CAB1-2
           WRITE IMPRE FROM SCAB1-2-1 AFTER 3 LINES
           WRITE IMPRE FROM SCAB1-2-2
           WRITE IMPRE FROM SCAB1-2-3
           WRITE IMPRE FROM SCAB1-2-4
           WRITE IMPRE FROM SCAB1-2-5. 

       LEER-SEC-MAEC.
           READ MAESTRO NEXT RECORD, AT END MOVE "S" TO FIN.

       BUCLE-LISTADOC.
           MOVE CLIENTEM  TO CLIENTE-DET
           MOVE EMPRESAM TO EMPRESA-DE
           MOVE LOCALIDADM TO LOCALIDAD-DE
           MOVE DIRECCIONM TO DIRECCION-DE
           MOVE TELEFONOM TO TELEFONO-DE
           MOVE C-POSTALM TO C-POSTAL-DE
           MOVE CIFM TO CIF-DET
           WRITE IMPRE FROM CUADRO1 AFTER 3 LINES
           WRITE IMPRE FROM CODIGO
           WRITE IMPRE FROM CAB1-3-1
           WRITE IMPRE FROM SCAB1-3-1
           WRITE IMPRE FROM LINE-DET1
           WRITE IMPRE FROM CAB1-3-2
           WRITE IMPRE FROM SCAB1-3-2
           WRITE IMPRE FROM LINE-DET2
           WRITE IMPRE FROM CAB1-3-3
           WRITE IMPRE FROM SCAB1-3-3
           WRITE IMPRE FROM LINE-DET3
           WRITE IMPRE FROM CUADRO2  
           PERFORM LEER-SEC-MAEC.

       ALTASC.
           OPEN I-O MAESTRO
           PERFORM INTRO-ALTASC
           PERFORM BUCLE-ALTAC UNTIL CLIENTEW = "*"
           CLOSE MAESTRO.

       INTRO-ALTASC.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**ALTAS DE CLIENTES**"
                   LINE 10 POSITION 20 REVERSE
           DISPLAY " "
           PERFORM INTRO-CLIENTEW.    

       BUCLE-ALTAC.
           PERFORM ACCESO-MAESTROC
           IF EXISTE = "S"
               DISPLAY CLIENTE, LINE 20 POSITION 10
               DISPLAY "ESTE CLIENTE YA EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM METERC
               PERFORM GRABAR-MAESTROC.
           PERFORM INTRO-ALTASC. 

       METERC.
           MOVE "S" TO INICIAL
           PERFORM INTRO-EMPRESAC
           PERFORM INTRO-LOCALIDADC
           PERFORM INTRO-DIRECCIONC
           PERFORM INTRO-TELEFONOC
           PERFORM INTRO-CPOSTALC
           PERFORM INTRO-CIFC
           DISPLAY "SI ESTA BIEN PULSA S"
                   LINE 20 POSITION 20
           DISPLAY "SI ESTA MAL PULSA 1,2,3,,, SEGUN EL CAMPO"
                  LINE 22 POSITION 10 
           ACCEPT NUMERO, LINE 22 POSITION 52
           PERFORM VALIDARC UNTIL NUMERO = "S"
           DISPLAY " ", ERASE.   

       ACCESO-MAESTROC.
           MOVE "S" TO EXISTE
           MOVE CLIENTEW TO CLIENTEM  
           READ MAESTRO, INVALID KEY PERFORM EXIST.     

       INTRO-EMPRESAWC.
           MOVE SPACES TO EMPRESAW 
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "TECLEE EL NOMBRE DE LA EMPRESA A CONSULTAR"
                   LINE 8 POSITION 20
           ACCEPT EMPRESAW, LINE 8 POSITION 65.

       INTRO-EMPRESAC.
           MOVE SPACES TO EMPRESAM
           DISPLAY "2.->TECLEE EL NOMBRE DE LA EMPRESA:"        
                   LINE 8 POSITION 20 
           ACCEPT EMPRESAM, LINE 8 POSITION 65.

       INTRO-LOCALIDADC.
           MOVE SPACES TO LOCALIDADM
           DISPLAY "3.->TECLEE LA LOCALIDAD DEL CLIENTE:"       
                   LINE 10 POSITION 20
           ACCEPT LOCALIDADM, LINE 10 POSITION 57.

       INTRO-DIRECCIONC.
           MOVE SPACES TO DIRECCIONM
           DISPLAY "4.->TECLEE LA DIRECCION DEL CLIENTE:"       
                   LINE 12 POSITION 20
           ACCEPT DIRECCIONM, LINE 12 POSITION 57.

       INTRO-TELEFONOC.
           MOVE ZEROS TO TELEFONOM
           DISPLAY "5.->TECLEE EL TELEFONO DEL CLIENTE:"       
                    LINE 14 POSITION 20
           ACCEPT TELEFONOM, LINE 14 POSITION 56.

       INTRO-CPOSTALC.
           MOVE SPACE TO C-POSTALM
           DISPLAY "6.->TECLEE EL CODIGO POSTAL:"       
                    LINE 16 POSITION 20
           ACCEPT C-POSTALM, LINE 16 POSITION 50.

       INTRO-CIFC.
           MOVE SPACE TO CIFM
           DISPLAY "7.->TECLEE EL CIF DEL CLIENTE:"       
                    LINE 18 POSITION 20
           ACCEPT CIFM, LINE 18 POSITION 52. 

       INTRO-CLIENTEW.
           MOVE SPACE TO CLIENTEW
           DISPLAY "1.->INTRODUCE EL CODIGO CLIENTE:", ERASE
                      LINE 4 POSITION 20 CONTROL "BCOLOR = BLUE"
           ACCEPT CLIENTEW, LINE 4 POSITION 55. 

       GRABAR-MAESTROC.
           WRITE R-MAESTRO, INVALID KEY DISPLAY "ERROR GRABACION".

       BAJASC.
           OPEN I-O MAESTRO
           PERFORM INTRO-BAJAC
           PERFORM BUCLE-BAJASC UNTIL CLIENTEW = "*"
           CLOSE MAESTRO.

       INTRO-BAJAC.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**BAJAS DE CLIENTES**"
                   LINE 2 POSITION 20 REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-CLIENTEW.

       BUCLE-BAJASC.
           PERFORM ACCESO-MAESTROC
           IF EXISTE = "N"
               DISPLAY CLIENTEW, LINE 20 POSITION 10     
               DISPLAY "ESTE CLIENTE NO EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM VISU-PROC
               DISPLAY "CONFIRMA LA BAJA (S/N):"
                       LINE 20 POSITION 5
               ACCEPT RESP, LINE 20 POSITION 45
               IF RESP = "S" OR RESP = "s"
                   DELETE MAESTRO,
                       INVALID KEY DISPLAY "ERROR DE BORRADO"
                              LINE 20 POSITION 20, BLINK, BEEP.     
           PERFORM INTRO-BAJAC.

       VISU-PROC.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                          " 
                  LINE 8 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "VISUALIZACION DE CLIENTE"
                  LINE 9 POSITION 32 REVERSE
           DISPLAY " " LINE 9 POSITION 58 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 11 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "     "
                   LINE 12 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "   CLIENTE NUM:"
                   LINE 12 POSITION 29 CONTROL "FCOLOR = GREEN"
           DISPLAY CLIENTEM
                   LINE 12  POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY "               "
                   LINE 12 POSITION 50 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "EMPRESA:"
                   LINE 13 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY EMPRESAM LINE 13 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 63 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "LOCALIDAD:"
                   LINE 14 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY LOCALIDADM 
                   LINE 14 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 63 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "DIRECCION:"
                   LINE 15 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY DIRECCIONM 
                   LINE 15 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 63 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "TELEFONO:"
                   LINE 16 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY TELEFONOM 
                   LINE 16 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "               
                   LINE 16 POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "C-POSTAL:"
                   LINE 17 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY C-POSTALM
                   LINE 17 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "
                   LINE 17 POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 18 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "CIF:" LINE 18 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY CIFM LINE 18 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 18 POSITION 40 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 19 POSITION 24 CONTROL "BCOLOR = READ".

       MODIFICACIONESC.
           OPEN I-O MAESTRO
           PERFORM INTRO-MODIC
           PERFORM BUCLE-MODIC UNTIL CLIENTEW = "*"
           CLOSE MAESTRO.

       INTRO-MODIC.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**MODIFICACION DE CLIENTES**"
                   LINE 10 POSITION 20
           DISPLAY " "
           PERFORM INTRO-CLIENTEW.

       BUCLE-MODIC.
           PERFORM ACCESO-MAESTROC
           IF EXISTE = "N"
               DISPLAY CLIENTE, LINE 20 POSITION 10
               DISPLAY "ESTE CLIENTE NO EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM VISU-PROC                            
               PERFORM VALIDARC
               PERFORM MODIFC.
           PERFORM INTRO-MODIC.

       MODIFC.
           REWRITE R-MAESTRO,
               INVALID KEY DISPLAY "REGISTRO NO MODIFICADO"
                           LINE 20 POSITION 20, BLINK, BEEP.

       CONS-CODC.
           OPEN INPUT MAESTRO
           PERFORM INTRO-CLA-PRINC
           PERFORM BUCLE-CLA-PRINC UNTIL CLIENTEW = "*"
           CLOSE MAESTRO. 

       INTRO-CLA-PRINC.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**CONSULTAS POR CLAVE PRINCIPAL**"
                   LINE 2 POSITION 20, REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-CLIENTEW.   

       BUCLE-CLA-PRINC.
           PERFORM ACCESO-MAESTROC
           IF EXISTE = "N"
               DISPLAY CLIENTE, LINE 20 POSITION 5
               DISPLAY "ESTE CLIENTE NO EXISTE.PULSE UNA TECLA"
                       LINE 20 POSITION 10, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 5
           ELSE
               PERFORM VISU-PROC 
               ACCEPT AVANZAR, LINE 20 POSITION 5.
           PERFORM INTRO-CLA-PRINC.

       CONS-DESC.
           OPEN INPUT MAESTRO
           PERFORM INTRO-CLA-SECC
           PERFORM BUCLE-CLA-SECC UNTIL EMPRESAW = "*"
           CLOSE MAESTRO.

       INTRO-CLA-SECC.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**CONSULTAS POR CLAVE SECUNDARIA**"
                   LINE 2 POSITION 20, REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-EMPRESAWC.

       BUCLE-CLA-SECC.
           PERFORM ACCESO-MAESTRO-SEC
           IF EXISTE = "N"
               DISPLAY EMPRESAW, LINE 20 POSITION 5
               DISPLAY "ESTA EMPRESA NO EXISTE"
                    LINE 20 POSITION 20, BLINK, BEEP
               ACCEPT AVANZAR LINE 20 POSITION 72
           ELSE
               PERFORM VISU-PROC 
               ACCEPT AVANZAR LINE 20 POSITION 72.
           PERFORM INTRO-CLA-SECC.

       ACCESO-MAESTRO-SEC.
           MOVE "S" TO EXISTE
           MOVE EMPRESAW TO EMPRESAM 
           READ MAESTRO, KEY IS EMPRESAM 
               INVALID KEY PERFORM EXIST.     

       PROVEDORES.
           MOVE ZEROS TO OPC-MENU
           PERFORM P-MENUP UNTIL OPC-MENU = "7"
           DISPLAY " " ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "FIN EJECUCION" LINE 15 POSITION 20.

       P-MENUP.
           PERFORM PANTALLA2
           PERFORM VALIDAR-OPC UNTIL OPC-MENU > "0" AND OPC-MENU < "8"
           IF OPC-MENU = "1"
             PERFORM ALTASP
           ELSE
             IF OPC-MENU = "2"
               PERFORM BAJASP
             ELSE
               IF OPC-MENU = "3"
                 PERFORM CONS-CODP
               ELSE
                 IF OPC-MENU = "4"
                   PERFORM CONS-DESP
                 ELSE
                   IF OPC-MENU = "5"
                     PERFORM MODIFICACIONESP
                   ELSE
                     IF OPC-MENU = "6"
                       PERFORM MENU-LISTADOP UNTIL OPC-MENU = "3".            

       VALIDARP.
           IF NUMERO = "1"
             PERFORM INTRO-PROVEW
           ELSE 
             IF NUMERO = "2"
               PERFORM INTRO-EMPRESAP
             ELSE
               IF NUMERO = "3"
                 PERFORM INTRO-LOCALIDADP
               ELSE
                 IF NUMERO = "4"
                   PERFORM INTRO-DIRECCIONP
                 ELSE
                   IF NUMERO = "5"
                     PERFORM INTRO-TELEFONOP
                   ELSE
                     IF NUMERO = "6"
                       PERFORM INTRO-CPOSTALP
                     ELSE
                       IF NUMERO = "7"
                         PERFORM INTRO-CIFP
                       ELSE
                         DISPLAY "OPCION ERRONEA, REPITA"
                                 LINE 24 POSITION 20.
           DISPLAY "SI ESTA BIEN PULSE S"
                   LINE 21 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,,, SEGUN EL CAMPO"
                   LINE 22 POSITION 10
           ACCEPT NUMERO, LINE 22 POSITION 52. 

       MENU-LISTADOP.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                   LINE 16 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "MENU DE LISTADO"
                   LINE 17 POSITION 34 REVERSE
           DISPLAY " " LINE 17 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 18 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 19 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "1.>IMPRESORA"
                   LINE 19 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "  "
                   LINE 19 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 20 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "2.>PANTALLA"
                   LINE 20 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "   "
                   LINE 20 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 21 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "3.>RETORNO"
                   LINE 21 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "    "
                   LINE 21 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 22 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " OPCION?:"
                   LINE 22 POSITION 36 REVERSE
           DISPLAY "   "
                   LINE 22 POSITION 47 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 22 POSITION 46 CONTROL "FCOLOR = READ"
           DISPLAY "                 "
                   LINE 23 POSITION 33 CONTROL "BCOLOR = READ"
           IF OPC-MENU = "1"
             PERFORM LISTADOP
           ELSE
             IF OPC-MENU = "2"
               OPEN INPUT PROVEDOR
               MOVE LOW-VALUE TO PROVE
               PERFORM LEER-SEC-MAEP
               MOVE "N" TO FIN
               PERFORM PROCES-VISP UNTIL FIN = "S"
               CLOSE PROVEDOR
             ELSE
               IF OPC-MENU = "3"
                 DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
               ELSE
                 DISPLAY "ERROR", ERASE
                  LINE 12 POSITION 20 SIZE 80 CONTROL "BCOLOR = BLUE".    
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE".

       PROCES-VISP.
             PERFORM VISU-PROP
             ACCEPT AVANZAR
             PERFORM LEER-SEC-MAEP.  

       LISTADOP.
           OPEN INPUT PROVEDOR        
                OUTPUT IMPRESO 
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**LISTADO DE PROVEEDORES**"
                   LINE 2 POSITION 20, REVERSE
           DISPLAY " "
           DISPLAY "PREPARE LA IMPRESORA Y PULSE UNA TECLA"
                   LINE 8 POSITION 15
           ACCEPT AVANZAR LINE 8 POSITION 50
           PERFORM CABECERASP
           MOVE "N" TO FIN
           PERFORM LEER-SEC-MAEP
           PERFORM BUCLE-LISTADOP UNTIL FIN = "S"
           DISPLAY "*FIN DE LISTADO*"
                   LINE 15 POSITION 25, BLINK
           CLOSE PROVEDOR, IMPRESO.

       CABECERASP.
           ACCEPT FECHA FROM DATE
           MOVE ANNO TO ANO-CA
           MOVE MES TO MES-CA
           MOVE DIA TO DIA-CA
           WRITE IMPRE FROM CAB-FECHA AFTER ADVANCING PAGE
           WRITE IMPRE FROM CAB1-1-1 AFTER 4 LINES
           WRITE IMPRE FROM CAB1-2
           WRITE IMPRE FROM SCAB1-2-1 AFTER 3 LINES
           WRITE IMPRE FROM SCAB1-2-2
           WRITE IMPRE FROM SCAB1-2-3
           WRITE IMPRE FROM SCAB1-2-4
           WRITE IMPRE FROM SCAB1-2-5. 

       LEER-SEC-MAEP.
           READ PROVEDOR NEXT RECORD, AT END MOVE "S" TO FIN.

       BUCLE-LISTADOP.
           MOVE PROVE    TO CLIENTE-DE
           MOVE ENTERPRISE TO EMPRESA-DE
           MOVE LOCALIDADP TO LOCALIDAD-DE
           MOVE DIRECCIONP TO DIRECCION-DE
           MOVE TELEFONOP TO TELEFONO-DE
           MOVE C-POSTALP TO C-POSTAL-DE
           MOVE CIFP TO CIF-DE
           WRITE IMPRE FROM CUADRO AFTER 3 LINES       
           WRITE IMPRE FROM CODIGO
           WRITE IMPRE FROM CAB1-3-1
           WRITE IMPRE FROM SCAB1-3-1
           WRITE IMPRE FROM LINE-DET1
           WRITE IMPRE FROM CAB1-3-2
           WRITE IMPRE FROM SCAB1-3-2
           WRITE IMPRE FROM LINE-DET2
           WRITE IMPRE FROM CAB1-3-3
           WRITE IMPRE FROM SCAB1-3-3
           WRITE IMPRE FROM LINE-DET3  
           PERFORM LEER-SEC-MAEP.

       ALTASP.
           OPEN I-O PROVEDOR       
           PERFORM INTRO-ALTASP
           PERFORM BUCLE-ALTAP UNTIL CLIENTEW = "*"
           CLOSE PROVEDOR.        

       INTRO-ALTASP.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**ALTAS DE PROVEEDORES**"
                   LINE 10 POSITION 20
           DISPLAY " "
           PERFORM INTRO-PROVEW.    

       BUCLE-ALTAP.
           PERFORM ACCESO-MAESTROP
           IF EXISTE = "S"
               DISPLAY PROVE, LINE 20 POSITION 10
               DISPLAY "ESTE PROVEEDOR YA EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM METERP
               PERFORM GRABAR-MAESTROP.
           PERFORM INTRO-ALTASP. 

       METERP.
           PERFORM INTRO-EMPRESAP
           PERFORM INTRO-LOCALIDADP
           PERFORM INTRO-DIRECCIONP
           PERFORM INTRO-TELEFONOP
           PERFORM INTRO-CPOSTALP
           PERFORM INTRO-CIFP
           DISPLAY "SI ESTA BIEN PULSA S"
                   LINE 20 POSITION 20
           DISPLAY "SI ESTA MAL PULSA 1,2,3,,, SEGUN EL CAMPO"
                  LINE 22 POSITION 10 
           ACCEPT NUMERO, LINE 22 POSITION 52
           PERFORM VALIDARP UNTIL NUMERO = "S"
           DISPLAY " ", ERASE.   

       INTRO-PROVEW.
           DISPLAY " ", ERASE 
           DISPLAY "1.->TECLEE EL NOMBRE DEL PROVEEDOR:"
                   LINE 6 POSITION 20
           ACCEPT CLIENTEW, LINE 6 POSITION 54.

       ACCESO-MAESTROP.
           MOVE "S" TO EXISTE
           MOVE CLIENTEW TO PROVE         
           READ PROVEDOR, INVALID KEY PERFORM EXIST.     

       INTRO-EMPRESAWP.
           MOVE SPACES TO EMPRESAW
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "2.->TECLEE EL NOMBRE DE LA EMPRESA A CONSULTAR:"
                   LINE 8 POSITION 10
           ACCEPT EMPRESAW, LINE 8 POSITION 60.

       INTRO-EMPRESAP.
           DISPLAY "2.->TECLEE EL NOMBRE DE LA EMPRESA:"        
                   LINE 8 POSITION 20
           ACCEPT ENTERPRISE, LINE 8 POSITION 56.

       INTRO-LOCALIDADP.
           DISPLAY "3.->TECLEE LA LOCALIDAD DEL CLIENTE:"       
                   LINE 10 POSITION 20
           ACCEPT LOCALIDADP, LINE 10 POSITION 57.

       INTRO-DIRECCIONP.
           DISPLAY "4.->TECLEE LA DIRECCION DEL CLIENTE:"       
                   LINE 12 POSITION 20
           ACCEPT DIRECCIONP, LINE 12 POSITION 57.

       INTRO-TELEFONOP.
           DISPLAY "5.->TECLEE EL TELEFONO DEL CLIENTE:"       
                    LINE 14 POSITION 20
           ACCEPT TELEFONOP, LINE 14 POSITION 56.

       INTRO-CPOSTALP.
           DISPLAY "6.->TECLEE EL CODIGO POSTAL:"       
                    LINE 16 POSITION 20
           ACCEPT C-POSTALP, LINE 16 POSITION 50.

       INTRO-CIFP.
           DISPLAY "7.->TECLEE EL CIF DEL CLIENTE:"       
                    LINE 18 POSITION 20
           ACCEPT CIFP, LINE 18 POSITION 52. 

       GRABAR-MAESTROP.
           WRITE R-PROVE, INVALID KEY DISPLAY "ERROR GRABACION".

       BAJASP.
           OPEN I-O PROVEDOR
           PERFORM INTRO-BAJAP
           PERFORM BUCLE-BAJASP UNTIL CLIENTEW = "*"
           CLOSE PROVEDOR.        

       INTRO-BAJAP.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**BAJAS DE PROVEEDORES**"
                   LINE 2 POSITION 20 REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-PROVEW.

       BUCLE-BAJASP.
           PERFORM ACCESO-MAESTROP
           IF EXISTE = "N"
               DISPLAY CLIENTEW, LINE 20 POSITION 10     
               DISPLAY "ESTE PROVEEDOR NO EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM VISU-PROP
               DISPLAY "CONFIRMA LA BAJA (S/N):"
                       LINE 20 POSITION 5
               ACCEPT RESP, LINE 20 POSITION 45
               IF RESP = "S" OR RESP = "s"
                   DELETE PROVEDOR,
                       INVALID KEY DISPLAY "ERROR DE BORRADO"
                              LINE 20 POSITION 20, BLINK, BEEP.     
           PERFORM INTRO-BAJAP.

       VISU-PROP.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                            " 
                  LINE 8 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "VISUALIZACION DE PROVEDOR"
                  LINE 9 POSITION 32 REVERSE
           DISPLAY " " LINE 9 POSITION 59 CONTROL "BCOLOR = READ"
           DISPLAY "                            "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 11 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "               "
                   LINE 12 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "  PROVEDOR NUM:"
                   LINE 12 POSITION 29 CONTROL "FCOLOR = GREEN"
           DISPLAY PROVE LINE 12  POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY "               "
                   LINE 12 POSITION 50 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "EMPRESA:"
                   LINE 13 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY ENTERPRISE
                   LINE 13 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 63 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "LOCALIDAD:"
                   LINE 14 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY LOCALIDADP
                   LINE 14 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 63 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "DIRECCION:"
                   LINE 15 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY DIRECCIONP
                   LINE 15 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "TELEFONO:"
                   LINE 16 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY TELEFONOP  
                   LINE 16 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "               
                   LINE 16 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "C-POSTAL:"
                   LINE 17 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY C-POSTALP 
                   LINE 17 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "
                   LINE 17 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 18 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "CIF:" LINE 18 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY CIFP LINE 18 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 18 POSITION 40 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 19 POSITION 24 CONTROL "BCOLOR = READ".

       MODIFICACIONESP.
           OPEN I-O PROVEDOR       
           PERFORM INTRO-MODIP
           PERFORM BUCLE-MODIP UNTIL CLIENTEW = "*"
           CLOSE PROVEDOR.

       INTRO-MODIP.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**MODIFICACION DE PROVEEDORES**"
                   LINE 10 POSITION 20
           DISPLAY " "
           PERFORM INTRO-PROVEW.          

       BUCLE-MODIP.
           PERFORM ACCESO-MAESTROP
           IF EXISTE = "N"
               DISPLAY CLIENTEW, LINE 20 POSITION 10
               DISPLAY "ESTE PROVEEDOR NO EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM VISU-PROP                            
               PERFORM VALIDARP
               PERFORM MODIFP.
           PERFORM INTRO-MODIP.

       MODIFP.
           REWRITE R-PROVE,
               INVALID KEY DISPLAY "REGISTRO NO MODIFICADO"
                           LINE 20 POSITION 20, BLINK, BEEP.

       CONS-CODP.
           OPEN INPUT PROVEDOR       
           PERFORM INTRO-CLA-PRINP
           PERFORM BUCLE-CLA-PRINP UNTIL CLIENTEW = "*"
           CLOSE PROVEDOR.

       INTRO-CLA-PRINP.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**CONSULTAS POR CLAVE PRINCIPAL**"
                   LINE 2 POSITION 20, REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-PROVEW.   

       BUCLE-CLA-PRINP.
           PERFORM ACCESO-MAESTROP
           IF EXISTE = "N"
               DISPLAY CLIENTEW, LINE 20 POSITION 5
               DISPLAY "ESTE PROVEEDOR NO EXISTE.PULSE UNA TECLA"
                       LINE 20 POSITION 10, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 5
           ELSE
               PERFORM VISU-PROP
               ACCEPT AVANZAR, LINE 20 POSITION 5.
           PERFORM INTRO-CLA-PRINP.

       CONS-DESP.
           OPEN INPUT PROVEDOR
           PERFORM INTRO-CLA-SECP
           PERFORM BUCLE-CLA-SECP UNTIL EMPRESAW = "*"
           CLOSE PROVEDOR.

       INTRO-CLA-SECP.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**CONSULTAS POR CLAVE SECUNDARIA**"
                   LINE 2 POSITION 20, REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-EMPRESAWP.

       BUCLE-CLA-SECP.
           PERFORM ACCESO-MAESTRO-SEP
           IF EXISTE = "N"
               DISPLAY EMPRESAW, LINE 20 POSITION 5
               DISPLAY "ESTA EMPRESA NO EXISTE"
                    LINE 20 POSITION 20, BLINK, BEEP
               ACCEPT AVANZAR LINE 20 POSITION 72
           ELSE
               PERFORM VISU-PROP 
               ACCEPT AVANZAR LINE 20 POSITION 72.
           PERFORM INTRO-CLA-SECP.

       ACCESO-MAESTRO-SEP.
           MOVE "S" TO EXISTE
           MOVE EMPRESAW TO ENTERPRISE
           READ PROVEDOR, KEY IS ENTERPRISE
               INVALID KEY PERFORM EXIST.     

       VAL-OPC.  
           DISPLAY "OPCION ERRONEA. TECLEE DE NUEVO" LINE 25 POSITION 20
           ACCEPT OPC-MENU LINE 23 POSITION 35.

       TRABAJADORES.           
           MOVE ZEROS TO OPC-MENU 
           PERFORM P-MENUT UNTIL OPC-MENU = "6"
           DISPLAY " " ERASE
           DISPLAY "FIN EJECUCION" LINE 15 POSITION 20.

       PANTALLA3.
           DISPLAY " ", SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "1.-ALTAS:"
              LINE 18 POSITION 21  CONTROL "FCOLOR = BROWN"
           DISPLAY "2.-BAJAS:"
              LINE 19 POSITION 21  CONTROL "FCOLOR = BROWN"
           DISPLAY "3.-CONSULTA POR COD:"
              LINE 18 POSITION 32  CONTROL "FCOLOR = BROWN"
           DISPLAY "4.-MODIF:"
              LINE 20 POSITION 22  CONTROL "FCOLOR = BROWN"
           DISPLAY "5.-LISTADO:"
              LINE 20 POSITION 32  CONTROL "FCOLOR = BROWN"
           DISPLAY "6.-RETORNO:"
              LINE 21 POSITION 27  CONTROL "FCOLOR = BROWN"
           DISPLAY "ELIGA OPCION: "
              LINE 23 POSITION 22 REVERSE BLINK
           ACCEPT OPC-MENU LINE 23 POSITION 36 REVERSE BLINK.

       P-MENUT.
           PERFORM PANTALLA3
           PERFORM VAL-OPC UNTIL OPC-MENU > "0" AND OPC-MENU < "7"
           IF OPC-MENU = "1"
             PERFORM ALTAST
           ELSE
             IF OPC-MENU = "2"
               PERFORM BAJAST
             ELSE
               IF OPC-MENU = "3"
                 PERFORM CONS-CODT
               ELSE
                IF OPC-MENU = "4"
                  PERFORM MODIFICACIONEST
                ELSE
                  IF OPC-MENU = "5"
                    PERFORM MENU-LISTADOT. 

       VALIDART.
           IF NUMERO = "1"
             PERFORM INTRO-CLIENTEWT
           ELSE 
               IF NUMERO = "2"
                 PERFORM INTRO-LOCALIDADT
               ELSE
                 IF NUMERO = "3"
                   PERFORM INTRO-DIRECCIONT
                 ELSE
                   IF NUMERO = "4"
                     PERFORM INTRO-TELEFONOT
                   ELSE
                     IF NUMERO = "5"
                       PERFORM INTRO-CPOSTALT
                     ELSE
                         DISPLAY "OPCION ERRONEA, REPITA"
                                 LINE 24 POSITION 20.
           DISPLAY "SI ESTA BIEN PULSE S"
                   LINE 21 POSITION 20
           DISPLAY "SI ESTA MAL PULSE 1,2,3,,, SEGUN EL CAMPO"
                   LINE 22 POSITION 10
           ACCEPT NUMERO, LINE 22 POSITION 52. 

       MENU-LISTADOT.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                   LINE 16 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "MENU DE LISTADO"
                   LINE 17 POSITION 34 REVERSE
           DISPLAY " " LINE 17 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 18 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 19 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "1.>IMPRESORA"
                   LINE 19 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "  "
                   LINE 19 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 20 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "2.>PANTALLA"
                   LINE 20 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "   "
                   LINE 20 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 21 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "3.>RETORNO"
                   LINE 21 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "    "
                   LINE 21 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 22 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " OPCION?:"
                   LINE 22 POSITION 36 REVERSE
           DISPLAY "   "
                   LINE 22 POSITION 47 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 22 POSITION 46 CONTROL "FCOLOR = READ"
           DISPLAY "                 "
                   LINE 23 POSITION 33 CONTROL "BCOLOR = READ"
           IF OPC-MENU = "1"
             PERFORM LISTADOT
           ELSE
             IF OPC-MENU = "2"
               OPEN INPUT PLANTILLA
               MOVE LOW-VALUE TO NOMBRE
               PERFORM LEER-SEC-MAET
               MOVE "N" TO FIN
               PERFORM PROCES-VIST UNTIL FIN = "S"
               CLOSE PLANTILLA
             ELSE
               IF OPC-MENU = "3"
                 DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
               ELSE
                 DISPLAY "ERROR", ERASE
                  LINE 12 POSITION 20 SIZE 80 CONTROL "BCOLOR = BLUE".    

       PROCES-VIST.
             PERFORM VISU-PROT
             ACCEPT AVANZAR
             PERFORM LEER-SEC-MAET. 

       LISTADOT.
           OPEN INPUT PLANTILLA
                OUTPUT IMPRESO 
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**LISTADO DE TRBAJADORES**"
                   LINE 2 POSITION 20, REVERSE
           DISPLAY " "
           DISPLAY "PREPARE LA IMPRESORA Y PULSE UNA TECLA"
                   LINE 8 POSITION 15
           ACCEPT AVANZAR LINE 8 POSITION 50
           PERFORM CABECERAST
           MOVE "N" TO FIN
           PERFORM LEER-SEC-MAET
           PERFORM BUCLE-LISTADOT UNTIL FIN = "S"
           DISPLAY "*FIN DE LISTADO*"
                   LINE 15 POSITION 25, BLINK
           CLOSE PLANTILLA, IMPRESO.

       CABECERAST.
           ACCEPT FECHA FROM DATE
           MOVE ANNO TO ANO-CA
           MOVE MES TO MES-CA
           MOVE DIA TO DIA-CA
           WRITE IMPRE FROM CAB-FECHA AFTER ADVANCING PAGE
           WRITE IMPRE FROM CAB1-1-3 AFTER 4 LINES
           WRITE IMPRE FROM CAB1-2
           WRITE IMPRE FROM SCAB1-2-1 AFTER 3 LINES
           WRITE IMPRE FROM SCAB1-2-2
           WRITE IMPRE FROM SCAB1-2-3
           WRITE IMPRE FROM SCAB1-2-4
           WRITE IMPRE FROM SCAB1-2-5. 

       LEER-SEC-MAET.
           READ PLANTILLA NEXT RECORD, AT END MOVE "S" TO FIN.

       BUCLE-LISTADOT.
           MOVE NOMBRE TO CLIENTE-DE
           MOVE LOCALIDADT TO LOCALIDAD-DE
           MOVE DIRECCIONT TO DIRECCION-DE
           MOVE TELEFONOT TO TELEFONO-DE
           MOVE C-POSTALT TO C-POSTAL-DE
           WRITE IMPRE FROM CUADRO AFTER 3 LINES       
           WRITE IMPRE FROM CODIGO
           WRITE IMPRE FROM CAB1-3-1
           WRITE IMPRE FROM SCAB1-3-1
           WRITE IMPRE FROM LINE-DET1
           WRITE IMPRE FROM CAB1-3-2
           WRITE IMPRE FROM SCAB1-3-2
           WRITE IMPRE FROM LINE-DET2
           WRITE IMPRE FROM CAB1-3-3
           WRITE IMPRE FROM SCAB1-3-3
           WRITE IMPRE FROM LINE-DET3  
           PERFORM LEER-SEC-MAET.

       ALTAST.
           OPEN I-O PLANTILLA
           PERFORM INTRO-ALTAST
           PERFORM BUCLE-ALTAT UNTIL CLIENTEW = "*"
           CLOSE PLANTILLA.

       INTRO-ALTAST.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**ALTAS DE TRABAJADORES**"
                   LINE 10 POSITION 20
           DISPLAY " "
           PERFORM INTRO-CLIENTEWT.    

       BUCLE-ALTAT.
           PERFORM ACCESO-MAESTROT
           IF EXISTE = "S"
               DISPLAY CLIENTEW, LINE 20 POSITION 10
               DISPLAY "ESTE TRABAJADOR YA EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM METERT
               PERFORM GRABAR-MAESTROT.
           PERFORM INTRO-ALTAST. 

       METERT.
           PERFORM INTRO-LOCALIDADT
           PERFORM INTRO-DIRECCIONT
           PERFORM INTRO-TELEFONOT
           PERFORM INTRO-CPOSTALT
           DISPLAY "SI ESTA BIEN PULSA S"
                   LINE 20 POSITION 20
           DISPLAY "SI ESTA MAL PULSA 1,2,3,,, SEGUN EL CAMPO"
                  LINE 22 POSITION 10 
           ACCEPT NUMERO, LINE 22 POSITION 52
           PERFORM VALIDART UNTIL NUMERO = "S"
           DISPLAY " ", ERASE.   

       ACCESO-MAESTROT.
           MOVE "S" TO EXISTE
           MOVE CLIENTEW TO NOMBRE  
           READ PLANTILLA, INVALID KEY PERFORM EXIST.     

       INTRO-LOCALIDADT.
           MOVE SPACES TO LOCALIDADT
           DISPLAY "2.->TECLEE LA LOCALIDAD DEL CLIENTE:"       
                   LINE 10 POSITION 20
           ACCEPT LOCALIDADT, LINE 10 POSITION 57.

       INTRO-DIRECCIONT.
           MOVE SPACES TO DIRECCIONT
           DISPLAY "3.->TECLEE LA DIRECCION DEL CLIENTE:"       
                   LINE 12 POSITION 20
           ACCEPT DIRECCIONT, LINE 12 POSITION 57.

       INTRO-TELEFONOT.
           MOVE ZEROS TO TELEFONOT
           DISPLAY "4.->TECLEE EL TELEFONO DEL CLIENTE:"       
                    LINE 14 POSITION 20
           ACCEPT TELEFONOT, LINE 14 POSITION 56.

       INTRO-CPOSTALT.
           MOVE SPACE TO C-POSTALT
           DISPLAY "5.->TECLEE EL CODIGO POSTAL:"       
                    LINE 16 POSITION 20
           ACCEPT C-POSTALT, LINE 16 POSITION 50.

       INTRO-CLIENTEWT.
           MOVE SPACE TO CLIENTEW
           DISPLAY "1.->INTRODUCE EL CODIGO CLIENTE:", ERASE
                      LINE 4 POSITION 20
           ACCEPT CLIENTEW, LINE 4 POSITION 55. 

       GRABAR-MAESTROT.
           WRITE R-TRAB, INVALID KEY DISPLAY "ERROR GRABACION".

       BAJAST.
           OPEN I-O PLANTILLA
           PERFORM INTRO-BAJAT
           PERFORM BUCLE-BAJAST UNTIL CLIENTEW = "*"
           CLOSE PLANTILLA.

       INTRO-BAJAT.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**BAJAS DE TRABAJADORES**"
                   LINE 2 POSITION 20 REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-CLIENTEWT.

       BUCLE-BAJAST.
           PERFORM ACCESO-MAESTROT
           IF EXISTE = "N"
               DISPLAY CLIENTEW, LINE 20 POSITION 10     
               DISPLAY "ESTE CLIENTE NO EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM VISU-PROT
               DISPLAY "CONFIRMA LA BAJA (S/N):"
                       LINE 20 POSITION 5
               ACCEPT RESP, LINE 20 POSITION 45
               IF RESP = "S" OR RESP = "s"
                   DELETE PLANTILLA,
                       INVALID KEY DISPLAY "ERROR DE BORRADO"
                              LINE 20 POSITION 20, BLINK, BEEP.     
           PERFORM INTRO-BAJAT.

       VISU-PROT.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                            " 
                  LINE 8 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "VISUALIZADO  TRABAJADOR "
                  LINE 9 POSITION 32 REVERSE
           DISPLAY " " LINE 9 POSITION 59 CONTROL "BCOLOR = READ"
           DISPLAY "                            "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 11 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 12 POSITION 19 CONTROL "BCOLOR = READ"
           DISPLAY "LOCALIDAD:"
                   LINE 12 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY LOCALIDADT
                   LINE 12 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 12 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 12 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "NOMBRE:" 
                      LINE 12 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY NOMBRE LINE 12 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "  " LINE 12 POSITION 62 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "DIRECCION:"
                   LINE 14 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY DIRECCIONT
                   LINE 14 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "TELEFONO:"
                   LINE 15 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY TELEFONOT 
                   LINE 15 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "               
                   LINE 15 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "C-POSTAL:"
                   LINE 16 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY C-POSTALT 
                   LINE 16 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                   LINE 16 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 17 POSITION 24 CONTROL "BCOLOR = READ".

       EXIST.
           MOVE "N" TO EXISTE.

       MODIFICACIONEST.
           OPEN I-O PLANTILLA
           PERFORM INTRO-MODIT
           PERFORM BUCLE-MODIT UNTIL CLIENTEW = "*"
           CLOSE PLANTILLA.         

       INTRO-MODIT.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**MODIFICACION DE TRABAJADORES**"
                   LINE 10 POSITION 20
           DISPLAY " "
           PERFORM INTRO-CLIENTEWT.

       BUCLE-MODIT.
           PERFORM ACCESO-MAESTROT
           IF EXISTE = "N"
               DISPLAY NOMBRE, LINE 20 POSITION 10
               DISPLAY "ESTE TRABAJADOR NO EXISTE"
                       LINE 20 POSITION 18, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 60
           ELSE
               PERFORM VISU-PROT                            
               PERFORM VALIDART
               PERFORM MODIFT.
           PERFORM INTRO-MODIT.

       MODIFT.
           REWRITE R-TRAB,
               INVALID KEY DISPLAY "REGISTRO NO MODIFICADO"
                           LINE 20 POSITION 20, BLINK, BEEP.

       CONS-CODT.
           OPEN INPUT PLANTILLA
           PERFORM INTRO-CLA-PRINT
           PERFORM BUCLE-CLA-PRINT UNTIL CLIENTEW = "*"
           CLOSE PLANTILLA. 

       INTRO-CLA-PRINT.
           DISPLAY " ", ERASE CONTROL "BCOLOR = BLUE"
           DISPLAY "**CONSULTAS POR CLAVE**"
                   LINE 2 POSITION 20, REVERSE LOW
           DISPLAY " "
           PERFORM INTRO-CLIENTEWT.   

       BUCLE-CLA-PRINT.
           PERFORM ACCESO-MAESTROT
           IF EXISTE = "N"
               DISPLAY NOMBRE, LINE 20 POSITION 5
               DISPLAY "ESTE TRABAJADOR NO EXISTE.PULSE UNA TECLA"
                       LINE 20 POSITION 10, BLINK, BEEP
               ACCEPT AVANZAR, LINE 20 POSITION 5
           ELSE
               PERFORM VISU-PROT
               ACCEPT AVANZAR, LINE 20 POSITION 5.
           PERFORM INTRO-CLA-PRINT.

       SERV-TRAB.
           PERFORM INICIAR1
           PERFORM MENU-SERV UNTIL OPC-MENU = "4".

       INICIAR1.
             OPEN I-O SERVICIOS
             MOVE 9999 TO TARJETA
             MOVE "S" TO EXISTE
             READ SERVICIOS, INVALID KEY MOVE "N" TO EXISTE
             IF EXISTE = "S" 
                MOVE 9999 TO TARJETW
             END-IF.
             IF EXISTE = "N" 
                MOVE 0000 TO TARJETW
                PERFORM INIC2 VARYING A FROM 1 BY 1 UNTIL A > 20
                               AFTER  B FROM 1 BY 1 UNTIL B > 5
                               AFTER  C FROM 1 BY 1 UNTIL C > 4
                                       OR FIN = "S"
             END-IF.    
             CLOSE SERVICIOS.

       INIC2.
           MOVE OBJETO TO OBJETO-D(A)
           MOVE SERVICIO TO SERV-D(A, B) 
           MOVE TRATAMIENTO TO TRAT-D(A, B, C)
           MOVE COSTE TO COSTE-D(A, B, C)
           READ SERVICIOS NEXT RECORD, AT END MOVE "S" TO FIN.

       MENU-SERV.
           DISPLAY " ", ERASE 
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR =BLUE"
           DISPLAY "                 "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 11 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "MENU SERVICIOS"
                   LINE 11 POSITION 33 REVERSE
           DISPLAY " " LINE 11 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "                   "
                   LINE 12 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "1.>ALTAS"
                   LINE 13 POSITION 32 CONTROL "FCOLOR = GREEN"
           DISPLAY "          "
                   LINE 13 POSITION 37 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "2.>MODIFICACIONES"
                   LINE 14 POSITION 32 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 14 POSITION 46 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "3.>LISTADO"
                    LINE 15 POSITION 32 CONTROL "FCOLOR = GREEN"
           DISPLAY "        "
                    LINE 15 POSITION 39 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "4.>RETORNO"
                    LINE 16 POSITION 32 CONTROL "FCOLOR = GREEN"
           DISPLAY "        "
                    LINE 16 POSITION 39 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 17 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "OPCION:" 
                   LINE 17 POSITION 34 CONTROL "FCOLOR = GREEN"
           ACCEPT OPC-MENU
                   LINE 17 POSITION 41 CONTROL "FCOLOR = GREEN"
           DISPLAY "        " 
                   LINE 17 POSITION 42 CONTROL "BCOLOR = READ"
           IF OPC-MENU = "1"
             PERFORM SUMA    
           ELSE
             IF OPC-MENU = "2"
               PERFORM MODI-TAB
             ELSE
               IF OPC-MENU = "3"
                  MOVE ZERO TO OPC-MENU
                  PERFORM MENU-LISTADOTAB UNTIL OPC-MENU = "3"
               ELSE
                 IF OPC-MENU = "4"
                  DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
               ELSE
                  DISPLAY "ERROR", ERASE
                  LINE 12 POSITION 20 SIZE 80 CONTROL "BCOLOR = BLUE".   

       COMPLETO.
             OPEN I-O SERVICIOS
             MOVE 2054 TO TARJETA
             MOVE "S" TO EXISTE
             READ SERVICIOS, INVALID KEY MOVE "N" TO EXISTE 
             IF FIN = "S"                 
                MOVE 1 TO A
             END-IF.
             IF EXISTE = "S"   
                MOVE 1 TO EXCET
                DISPLAY "REGISTRO COMPLETO", ERASE
                 LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE"
                CLOSE SERVICIOS 
             ELSE                
                MOVE 0 TO EXCET
                CLOSE SERVICIOS
             END-IF.

       PROTEG3.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "ESTA OPCION ANULA LOS DATOS ANTERIORES"
                   LINE 12 POSITION 20
           DISPLAY "       CONFIRMA OPCION(S/N)"
                   LINE 13 POSITION 20
           ACCEPT RESP LINE 13 POSITION 50.

       SUMA.
           PERFORM COMPLETO 
           IF EXCET = 0
            PERFORM CREAR1 UNTIL OBJETO-W = "*".

       CREAR1.
           DISPLAY " ", ERASE  SIZE 80 CONTROL "BCOLOR = BLUE" 
           DISPLAY "INTRODUZCA NOMBRE DE PRODUCTO A TRATAR:", ERASE
                   LINE 10 POSITION 10 CONTROL "BCOLOR = BLUE"
           ACCEPT OBJETO-W LINE 10 POSITION 50
           IF OBJETO-W = "*"
              DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE
              ADD 1 TO A
              MOVE OBJETO-W TO OBJETO-D(A)
              PERFORM CREAR1-1.

       CREAR1-1. 
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE" 
           DISPLAY "INTRODUZCA NOMBRE DE PRODUCTO A TRATAR:", ERASE
                   LINE 10 POSITION 10 CONTROL "BCOLOR = BLUE"
           DISPLAY OBJETO-W LINE 10 POSITION 50
           DISPLAY "INTRODUZCA EL NOMBRE DEL TRATAMIENTO A SEGUIR:"
              LINE 12 POSITION 10 CONTROL "BCOLOR = BLUE"              
           ACCEPT SERV-W LINE 12 POSITION 60
           PERFORM SUBORDEN1 VARYING B FROM 1 BY 1 UNTIL B > 5
                              OR SERV-W = "*".

       SUBORDEN1.
           IF SERV-W = "*"
             DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE
             MOVE SERV-W TO SERV-D(A, B)        
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUZCA NOMBRE DE PRODUCTO A TRATAR:", ERASE
                   LINE 10 POSITION 10 CONTROL "BCOLOR = BLUE"
           DISPLAY OBJETO-W LINE 10 POSITION 50
           DISPLAY "INTRODUZCA EL NOMBRE DEL TRATAMIENTO A SEGUIR:"
              LINE 12 POSITION 10 CONTROL "BCOLOR = BLUE"              
           DISPLAY SERV-W LINE 12 POSITION 60
           DISPLAY "INTRODUZCA FORMA DE TRATAMIENTO:"         
                   LINE 14 POSITION 10 
           ACCEPT TRAT-W LINE 14 POSITION 45
           PERFORM SUBORDEN1-1 VARYING C FROM 1 BY 1 UNTIL C > 4
                                  OR TRAT-W = "*"
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE" 
           DISPLAY "INTRODUZCA NOMBRE DE PRODUCTO A TRATAR:", ERASE
                   LINE 10 POSITION 10 CONTROL "BCOLOR = BLUE"
           DISPLAY OBJETO-W LINE 10 POSITION 50
           DISPLAY "INTRODUZCA EL NOMBRE DEL TRATAMIENTO A SEGUIR:"
              LINE 12 POSITION 10 CONTROL "BCOLOR = BLUE"              
           ACCEPT SERV-W LINE 12 POSITION 60.

       SUBORDEN1-1.
           IF TRAT-W = "*"
             DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           ELSE  
             DISPLAY "INTRODUZCA EL COSTE:"
                     LINE 16 POSITION 10
             ACCEPT COSTE-W LINE 16 POSITION 35
             PERFORM SUBORDEN3-1
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUZCA NOMBRE DE PRODUCTO A TRATAR:", ERASE
                   LINE 10 POSITION 10 CONTROL "BCOLOR = BLUE"
           DISPLAY OBJETO-W LINE 10 POSITION 50
           DISPLAY "INTRODUZCA EL NOMBRE DEL TRATAMIENTO A SEGUIR:"
              LINE 12 POSITION 10 CONTROL "BCOLOR = BLUE"              
           DISPLAY SERV-W LINE 12 POSITION 60
           DISPLAY "INTRODUZCA FORMA DE TRATAMIENTO:"         
                   LINE 14 POSITION 10 
           ACCEPT TRAT-W LINE 14 POSITION 45.

       SUBORDEN3-1.  
           MOVE TRAT-W TO TRAT-D(A, B, C)
           MOVE COSTE-W TO COSTE-D(A, B, C)
           IF A-1 = A
              PERFORM GRAB2
           ELSE
              PERFORM GRAB1
           END-IF.

       MODI-TAB.
           PERFORM PROTEG3
           IF RESP = "S"
             OPEN I-O SERVICIOS
             DISPLAY "INDICA EL OBJETO(A):"
                     LINE 16 POSITION 20
             ACCEPT A LINE 16 POSITION 42
             DISPLAY "SERVICIO(B):"
                     LINE 17 POSITION 20
             ACCEPT B LINE 17 POSITION 34
             DISPLAY "TRATAMIENTO Y COSTE(C):"
                     LINE 18 POSITION 20
             ACCEPT C LINE 18 POSITION 47
             STRING A DELIMITED BY SIZE
                    B DELIMITED BY SIZE
                    C DELIMITED BY SIZE
                    INTO TARJETA
             READ SERVICIOS, INVALID KEY MOVE "N" TO EXISTE
             MOVE OBJETO TO OBJETO-W
             MOVE A TO A-1 
             IF EXISTE = "S"
                MOVE OBJETO TO OBJETO-W
                PERFORM REP VARYING B FROM 1 BY 1 UNTIL B > 5
                              AFTER C FROM 1 BY 1 UNTIL C > 4
                              OR EXISTE = "N"
                 MOVE A-1 TO A
                 PERFORM CREAR1-1 
                 MOVE "N" TO EXISTE
             ELSE
                 DISPLAY "REGISTRO NO ENCONTRADO", ERASE
                     LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE"
                 ACCEPT AVANCE
             END-IF.
             CLOSE SERVICIOS.

       REP.
           STRING A DELIMITED BY SIZE
                  B DELIMITED BY SIZE
                  C DELIMITED BY SIZE
                  INTO TARJETA
           DELETE SERVICIOS, INVALID KEY DISPLAY "NO BORRADO" 
           MOVE "S" TO EXISTE.
           READ SERVICIOS INVALID KEY MOVE "N" TO EXISTE.

       GRAB2.
           MOVE A TO COD-OBJETO
           MOVE OBJETO-W TO OBJETO
           MOVE B TO COD-SERV
           MOVE SERV-D(A, B) TO SERVICIO
           MOVE C TO COD-TRAT
           MOVE TRAT-D(A, B, C) TO TRATAMIENTO
           MOVE COSTE-D(A, B, C) TO COSTE
           PERFORM GRAB-FICHE.

       GRAB1.
           OPEN I-O SERVICIOS
           IF TARJETW = 9999
             PERFORM GRAB-FICHA
           ELSE
             PERFORM GRAB-FICHE
           END-IF.
           CLOSE SERVICIOS.

       GRAB-FICHE.
           STRING A DELIMITED BY SIZE
                  B DELIMITED BY SIZE
                  C DELIMITED BY SIZE
                  INTO TARJETA
           MOVE A TO COD-OBJETO
           MOVE OBJETO-D(A) TO OBJETO
           MOVE B TO COD-SERV
           MOVE SERV-D(A, B) TO SERVICIO
           MOVE C TO COD-TRAT
           MOVE TRAT-D(A, B, C) TO TRATAMIENTO
           MOVE COSTE-D(A, B, C) TO COSTE
           WRITE R-SERV, INVALID KEY DISPLAY "ERROR GRABACION TABLA".

       GRAB-FICHA.
           STRING A DELIMITED BY SIZE
                  B DELIMITED BY SIZE
                  C DELIMITED BY SIZE
                  INTO TARJETA
           MOVE A TO COD-OBJETO
           MOVE OBJETO-D(A) TO OBJETO
           MOVE B TO COD-SERV
           MOVE SERV-D(A, B) TO SERVICIO
           MOVE C TO COD-TRAT
           MOVE TRAT-D(A, B, C) TO TRATAMIENTO
           MOVE COSTE-D(A, B, C) TO COSTE
           REWRITE R-SERV 
                 INVALID KEY DISPLAY "ERROR GRABACION TABLA".

       MENU-LISTADOTAB.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                   LINE 16 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "MENU DE LISTADO"
                   LINE 17 POSITION 34 REVERSE
           DISPLAY " " LINE 17 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 18 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 19 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "1.>IMPRESORA"
                   LINE 19 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "  "
                   LINE 19 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 20 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "2.>PANTALLA"
                   LINE 20 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "   "
                   LINE 20 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 21 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "3.>RETORNO"
                   LINE 21 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "    "
                   LINE 21 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 22 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " OPCION?:"
                   LINE 22 POSITION 36 REVERSE
           DISPLAY "   "
                   LINE 22 POSITION 48 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 22 POSITION 47 CONTROL "FCOLOR = READ"
           DISPLAY "                 "
                   LINE 23 POSITION 33 CONTROL "BCOLOR = READ"
           IF OPC-MENU = "1"
             PERFORM LISTA-TAB
           ELSE
             IF OPC-MENU = "2"
               OPEN INPUT SERVICIOS
               PERFORM LEER-SEC-MAES
               MOVE "N" TO FIN
               PERFORM PROCES-VISER UNTIL FIN = "S"
               CLOSE SERVICIOS
             ELSE
               IF OPC-MENU = "3"
                 DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
               ELSE
                 DISPLAY "ERROR", ERASE
                  LINE 12 POSITION 20 SIZE 80 CONTROL "BCOLOR = BLUE".    
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE".  

       PROCES-VISER.
             PERFORM VISU-PROSER
             ACCEPT AVANZAR
             PERFORM LEER-SEC-MAES.  

       VISU-PROSER.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                            " 
                  LINE 8 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "VISUALIZACION DE SERVICIOS"
                  LINE 9 POSITION 32 REVERSE
           DISPLAY " " LINE 9 POSITION 59 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 11 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "     "
                   LINE 12 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "    OBJETO NUM:"
                   LINE 12 POSITION 29 CONTROL "FCOLOR = GREEN"
           DISPLAY TARJETA LINE 12  POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY "          "
                   LINE 12 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "     "
                   LINE 13 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "    OBJETO NUM:"
                   LINE 13 POSITION 29 CONTROL "FCOLOR = GREEN"
           DISPLAY OBJETO LINE 13  POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY "   "
                   LINE 13 POSITION 75 CONTROL "BCOLOR = READ"   
           DISPLAY " " LINE 14 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "SERVICIO:"
                   LINE 14 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY SERVICIO LINE 13 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "TRATAMIENTO:"
                   LINE 15 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY TRATAMIENTO
                   LINE 15 POSITION 37 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "COSTE:"
                   LINE 16 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY COSTE     
                   LINE 16 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "              " 
                   LINE 16 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 17 POSITION 24 CONTROL "BCOLOR = READ".

       LISTA-TAB.
           OPEN INPUT SERVICIOS
           ACCEPT FECHA FROM DATE
           MOVE ANNO TO ANO-CA
           MOVE MES TO MES-CA
           MOVE DIA TO DIA-CA
           WRITE IMPRE FROM CAB-FECHA AFTER ADVANCING PAGE
           MOVE "N" TO FIN
           PERFORM L-TAB1 UNTIL FIN = "S"
           CLOSE SERVICIOS.

       L-TAB1.
           WRITE IMPRE FROM CAB-TAB1 AFTER 4 LINES
           MOVE OBJETO TO OBJETO-DE
           MOVE SERVICIO TO SERV-DE
           WRITE IMPRE FROM TAB1-1 AFTER 3 LINES
           MOVE TRATAMIENTO TO TRAT-DE
           MOVE COSTE TO COSTE-DE
           WRITE IMPRE FROM TAB1-2 AFTER 2 LINES
           PERFORM LEER-SEC-MAES.

       LEER-SEC-MAES.
           READ SERVICIOS NEXT RECORD, AT END MOVE "S" TO FIN.

       IVA-T.
           PERFORM PROTEGER.

       PROTEGER.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "ESTA OPERACION ANULA LOS DATOS ANTERIORES"
                   LINE 12 POSITION 20
           DISPLAY "     CONFIRMA OPERACION(S/N)"
                   LINE 13 POSITION 20
           ACCEPT RESP LINE 13 POSITION 50
           IF RESP = "S" OR RESP = "s"
               PERFORM CREACION2.

       CREACION2.
           OPEN I-O IVA
           PERFORM CREAR2 VARYING I FROM 1 BY 1 UNTIL I > 3
           PERFORM GRABACION3
           CLOSE IVA.

       CREAR2.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE EL TIPO DE IVA:"
                   LINE 15 POSITION 20
           ACCEPT IVA-W, LINE 15 POSITION 50
           MOVE IVA-W TO IVA-D(I)
           MOVE PORC-W TO PORCEN-D(I).    

       GRABACION3.
           PERFORM GRABDOS VARYING I FROM 1 BY 1 UNTIL I > 3.

       GRABDOS.
           MOVE IVA-D(I) TO C-IVA
           MOVE I TO COD-IVA
           MOVE PORCEN-D(I) TO PORCENTAJE
           REWRITE R-IVA
                 INVALID KEY DISPLAY "ERROR GRABACION TAB2".

       PAGO-T.
           PERFORM PROTEGE2.

       PROTEGE2.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "ESTA OPCION ANULA LOS DATOS ANTERIORES"
                   LINE 12 POSITION 20
           DISPLAY "       CONFIRMA OPCION(S/N)"
                   LINE 13 POSITION 20
           ACCEPT RESP LINE 13 POSITION 50
           IF RESP = "S" OR RESP = "s"
               PERFORM CREACION3.

       CREACION3.
           OPEN I-O PAGO
           PERFORM CREAR3 VARYING I FROM 1 BY 1 UNTIL I > 10
           PERFORM GRABACION4
           CLOSE PAGO.

       CREAR3.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY I " PLAZO:QUE TIPO DE INTERES SE RECARGA?:"
                  ERASE, LINE 15 POSITION 15
           ACCEPT INTE-W, LINE 15 POSITION 60
           MOVE INTE-W TO INTE-D(I).

       GRABACION4.
           PERFORM GRABAR4 VARYING I FROM 1 BY 1 UNTIL I > 10.

       GRABAR4.
           MOVE PLAZO-D(I) TO PLAZO
           MOVE INTE-D(I) TO INTERES
           MOVE PORCENT(I) TO PORCEN-T
           MOVE I TO COD-PAGO
           REWRITE R-PAGO  
               INVALID KEY DISPLAY "ERROR GRABACION TAB3".

       FACTURACION.
           PERFORM MENU-FACTURACION UNTIL OPC-MENU = "5".

       MENU-FACTURACION.
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                  "
                LINE 8 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY "MENU FACTURACION"
                   LINE 9 POSITION 31 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 9 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                   LINE 10 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 11 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "1>ORDENES DE PEDIDOS"
                   LINE 11 POSITION 28 CONTROL "FCOLOR = GREEN"
           DISPLAY "   " LINE 11 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 12 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "2>GESTION DE ALBARANES" 
                   LINE 12 POSITION 28 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 12 POSITION 50 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "3>GESTION DE FACTURAS"
                   LINE 13 POSITION 28 CONTROL "FCOLOR = GREEN"
           DISPLAY "  " LINE 13 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "4>GESTION DE RECIBOS"
                   LINE 14 POSITION 28 CONTROL "FCOLOR = GREEN"
           DISPLAY "   " LINE 14 POSITION 48 CONTROL "FCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "5>REGRESAR"
                   LINE 15 POSITION 28 CONTROL "BCOLOR = READ"
           DISPLAY "             "
                   LINE 15 POSITION 38 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                 LINE 16 POSITION 27 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 16 POSITION 36
           IF OPC-MENU = "1"
             PERFORM ORDENES
           ELSE   
           IF OPC-MENU = "2"
             PERFORM ALBARAN
           ELSE
           IF OPC-MENU = "3"
             PERFORM FACTURA
           ELSE
           IF OPC-MENU = "4"
             PERFORM RECIBO
           ELSE
           IF OPC-MENU = "5"
             DISPLAY "FIN DE EJECUCION"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE"
           ELSE
             DISPLAY "ERROR"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE".

       ORDENES.
           OPEN OUTPUT PEDIDO
                I-O MAESTRO, SERVICIOS
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "TRABAJAS POR CODIGO(C) O NOMBRE DE EMPRESA(E):"
                   LINE 10 POSITION 10                   
           ACCEPT FORMA LINE 10 POSITION 60
           PERFORM PED UNTIL FORMA = "*"
           CLOSE PEDIDO, MAESTRO, SERVICIOS.

       PED.  
           IF FORMA = "C"
             DISPLAY "INTRODUCE EL CODIGO:"
                     LINE 12 POSITION 10
             ACCEPT CLIENTEM LINE 12 POSITION 30
             READ MAESTRO 
           ELSE
             IF FORMA = "E" THEN
               DISPLAY "INTRODUCE EL NOMBRE CORRECTO DE LA EMPRESA:"
                       LINE 12 POSITION 10 
               ACCEPT EMPRESAM LINE 12 POSITION 43
               READ MAESTRO 
                KEY IS EMPRESAM.
           PERFORM TRATAR
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "TRABAJAS POR CODIGO(C) O NOMBRE DE EMPRESA(E):"
                   LINE 10 POSITION 10                   
           ACCEPT FORMA LINE 10 POSITION 60.

       TRATAR.
           ACCEPT FECHA FROM DATE
             DISPLAY "INDICA EL OBJETO(A):"
                     LINE 16 POSITION 20
             ACCEPT A LINE 16 POSITION 42
             DISPLAY "SERVICIO(B):"
                     LINE 17 POSITION 20
             ACCEPT B LINE 17 POSITION 34
             DISPLAY "TRATAMIENTO Y COSTE(C):"
                     LINE 18 POSITION 20
             ACCEPT C LINE 18 POSITION 47
             STRING A DELIMITED BY SIZE
                    B DELIMITED BY SIZE
                    C DELIMITED BY SIZE
                    INTO TARJETA
             READ SERVICIOS RECORD
                  INVALID KEY MOVE "N" TO EXISTE
           PERFORM GRAB-PED.

       GRAB-PED.
           MOVE OBJETO TO OBJETOP
           MOVE SERVICIO TO SERVP
           MOVE TRATAMIENTO TO TRATP                     
           MOVE COSTE TO COSTEP
           MOVE MES TO MES-P              
           MOVE DIA TO DIA-P
           MOVE CLIENTEM TO CLIENTEP
           ADD 1 TO CONTADOR
           MOVE CONTADOR TO NUM
           WRITE R-PEDIDO.

       ALBARAN.    
           PERFORM MENU-ALBARAN UNTIL OPC-MENU = "5".

       MENU-ALBARAN.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                LINE 8 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY "MENU ALBARANAJE "
                   LINE 9 POSITION 31 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 9 POSITION 46 CONTROL "BCOLOR = READ"
           DISPLAY "                       "
                   LINE 10 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "   " 
                   LINE 11 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "1>CONFIGURACION"     
                   LINE 11 POSITION 30 CONTROL "FCOLOR = GREEN"
           DISPLAY "    " LINE 11 POSITION 43 CONTROL "BCOLOR = READ"
           DISPLAY "     " 
                   LINE 12 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "2>MODIFICACION" 
                   LINE 12 POSITION 32 CONTROL "FCOLOR = GREEN"
           DISPLAY "     " 
                   LINE 12 POSITION 42 CONTROL "BCOLOR = READ"
           DISPLAY "       " 
                   LINE 13 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "3>ANULACION"
                   LINE 13 POSITION 34 CONTROL "FCOLOR = GREEN"
           DISPLAY "      "
                   LINE 13 POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY "        " 
                   LINE 14 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "4>LISTADO"
                   LINE 14 POSITION 35 CONTROL "FCOLOR = GREEN"
           DISPLAY "       " 
                   LINE 14 POSITION 43 CONTROL "FCOLOR = READ"
           DISPLAY "       " 
                   LINE 15 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "5>REGRESAR"
                   LINE 15 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "       "
                   LINE 15 POSITION 43 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                 LINE 16 POSITION 27 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 17 POSITION 37
           IF OPC-MENU = "1"
             PERFORM CONFIGURACION
           ELSE   
           IF OPC-MENU = "2"
             PERFORM MODIFICACION
           ELSE
           IF OPC-MENU = "3"
             PERFORM ANULACION
           ELSE
           IF OPC-MENU = "4"
             PERFORM LISTADO-ALBAR
           ELSE
           IF OPC-MENU = "5"
             DISPLAY "FIN DE EJECUCION"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE"
           ELSE
             DISPLAY "ERROR"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE".

       CONFIGURACION.
           PERFORM INICIALB UNTIL INICIALBAR = "S"
           PERFORM CONFIG.

       INICIALB.
           OPEN OUTPUT ALBARAN
           MOVE ZEROS TO ALB-NUM
           MOVE SPACE TO COD-CLIA
           MOVE DIA TO DIA-ALB
           MOVE MES TO MES-ALB 
           MOVE ZEROS TO CANTIDAD
           MOVE SPACE TO CONCEPTO
           MOVE SPACE TO SERVI-AL
           MOVE SPACE TO TRATA-AL
           MOVE ZEROS TO IMPORTE
           MOVE ZEROS TO COD-IVA
           MOVE "S" TO INICIALBAR
           WRITE R-ALBARAN
           CLOSE ALBARAN.

       CONFIG.
           OPEN OUTPUT ALBARAN          
                I-O PEDIDO, MAESTRO, IVA, SERVICIOS
           ADD 1 TO CONTADOR4
           MOVE CONTADOR4 TO ALB-NUM
           MOVE LOW-VALUE TO NUM   
           READ PEDIDO NEXT RECORD
           MOVE CLIENTEP TO CLIENTE
           READ MAESTRO
           MOVE CLIENTE TO COD-CLIA
           ACCEPT FECHA FROM DATE
           MOVE MES TO MES-ALB
           MOVE DIA TO DIA-ALB
           STRING OBJETOP DELIMITED BY SIZE          
                  SERVP   DELIMITED BY SIZE
                  TRATP   DELIMITED BY SIZE
                  INTO    CODIGOP             
           MOVE CODIGOP TO TARJETA  
           READ SERVICIOS 
           PERFORM VISU-PROSER
           MOVE OBJETO TO CONCEPTO
           MOVE SERVICIO TO SERVI-AL
           MOVE TRATAMIENTO TO TRATA-AL
           MOVE COSTE TO IMPORTE
           DISPLAY " ", ERASE  SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE CODIGO DE IVA" 
                       LINE 12 POSITION 25
           ACCEPT COD-IVA LINE 12 POSITION 50
           READ IVA, INVALID KEY MOVE "N" TO EXISTE
           PERFORM IMPUESTO
           WRITE R-ALBARAN
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "QUIERES CONFIGURAR OTRA?:"
                   LINE 12 POSITION 20
           ACCEPT RESP LINE 12 POSITION 52
           IF RESP = "S" OR RESP = "s"
               PERFORM CONFIG
           END-IF.
           CLOSE ALBARAN, PEDIDO, MAESTRO, SERVICIOS, IVA. 

       IMPUESTO.
           IF EXISTE = "S"
              MOVE C-IVA TO COD-IVALB
           ELSE
              DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
              DISPLAY "TECLEE CODIGO CORRECTO(1,2,3)"
                      LINE 12 POSITION 25
              READ IVA, INVALID KEY MOVE "N" TO EXISTE
              PERFORM IMPUES.                                       

       MODIFICACION.
           OPEN I-O ALBARAN
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE EL NUMERO DE ALBARAN A TRATAR"
                   LINE 12 POSITION 20 
           ACCEPT ALB-NUM LINE 12 POSITION 60
           READ ALBARAN
           PERFORM VISU-PROA
           PERFORM VALIDARALB UNTIL OPC-MENU = "S"
           REWRITE R-ALBARAN 
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "DESEAS MODIFICAR OTRA FICHA?:"
                    LINE 12 POSITION 20
           ACCEPT RESP LINE 12 POSITION 50
           IF RESP = "S" OR RESP = "s"
             PERFORM MODIFICACION.         
           CLOSE ALBARAN.   

       VALIDARALB.
           DISPLAY "QUE CAMPO DESEAS MODIFICAR (S/SALIR):"
                   LINE 18 POSITION 30
           DISPLAY "1>ENTREGA/2>LOCALIDAD/3>DIRECCION"
                   LINE 19 POSITION 26
           DISPLAY "4>TELEFONO/5>C-POSTAL/6>CIF"
                   LINE 20 POSITION 28
           DISPLAY "7>CANTIDAD/8>CONCEPTO/9>PRECIO"
                   LINE 21 POSITION 27
           ACCEPT OPC-MENU
           IF OPC-MENU = "1"
              ACCEPT EMPRESAM LINE 13 POSITION 33.
           IF OPC-MENU = "2"  
              ACCEPT LOCALIDADM LINE 14 POSITION 35.
           IF OPC-MENU = "3"
              ACCEPT DIRECCIONM LINE 15 POSITION 35.
           IF OPC-MENU = "4"
              ACCEPT TELEFONOM LINE 16 POSITION 34.
           IF OPC-MENU = "5"
              ACCEPT C-POSTALM LINE 17 POSITION 34.
           IF OPC-MENU = "6"
              ACCEPT CIFM LINE 18 POSITION 29.
           IF OPC-MENU = "7"
              ACCEPT CANTIDAD LINE 19 POSITION 34.
           IF OPC-MENU = "8"
              ACCEPT CONCEPTO LINE 20 POSITION 25.
           IF OPC-MENU = "9"
              ACCEPT IMPORTE LINE 22 POSITION 32.

       ANULACION.
           OPEN I-O ALBARAN
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE EL NUMERO DE ALBARAN A ANULAR"
                   LINE 12 POSITION 20
           ACCEPT ALB-NUM LINE 12 POSITION 61
           READ ALBARAN
           PERFORM VISU-PROA
           ACCEPT AVANZAR
           DISPLAY "CONFIRMA LA BAJA(S/N)"
               LINE 24 POSITION 35
           ACCEPT RESP LINE 24 POSITION 57
           IF RESP = "S" OR RESP = "s"
              DELETE ALBARAN RECORD.
           CLOSE ALBARAN. 

       LISTADO-ALBAR.
           PERFORM MENU-LISTADOALB UNTIL OPC-MENU = "5".  

       MENU-LISTADOALB.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                   LINE 16 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "MENU DE LISTADO"
                   LINE 17 POSITION 34 REVERSE
           DISPLAY " " LINE 17 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 18 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 19 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "1.>IMPRESORA"
                   LINE 19 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "                "
                   LINE 19 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "  " LINE 20 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "2.>PANTALLA"
                   LINE 20 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "   "
                   LINE 20 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 21 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "3.>RETORNO"
                   LINE 21 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "    "
                   LINE 21 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 22 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " OPCION?:"
                   LINE 22 POSITION 36 REVERSE
           DISPLAY "   "
                   LINE 22 POSITION 47 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 21 POSITION 46 CONTROL "FCOLOR = READ"
           IF OPC-MENU = "1"
             PERFORM LISTADO-AL
           ELSE
             IF OPC-MENU = "2"
               OPEN INPUT ALBARAN
               MOVE LOW-VALUE TO ALB-NUM
               PERFORM LEER-SEC-MAEA
               MOVE "N" TO FIN
               PERFORM PROCES-VISA UNTIL FIN = "S"
               CLOSE ALBARAN
             ELSE
               IF OPC-MENU = "3"
                 DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
               ELSE
                 DISPLAY "ERROR", ERASE
                  LINE 12 POSITION 20 SIZE 80 CONTROL "BCOLOR = BLUE".    

       LISTADO-AL.
           OPEN INPUT ALBARAN
                I-O  MAESTRO
           MOVE LOW-VALUE TO ALB-NUM
           MOVE "N" TO FIN 
           PERFORM LEER-SEC-MAEA
           PERFORM CABE
           PERFORM B-LIS UNTIL FIN = "S".

       CABE.
           WRITE IMPRE FROM CAB1-2 AFTER ADVANCING PAGE
           WRITE IMPRE FROM CABECERA1 AFTER 4 LINES.

       B-LIS.
           ACCEPT FECHA FROM DATE
           MOVE ANNO TO AN-DE
           MOVE MES-ALB TO MES-DE
           MOVE DIA-ALB TO DIA-DE
           MOVE COD-CLIA TO CLIENTE 
           READ MAESTRO RECORD
           MOVE EMPRESAM TO EMPRE-DE                   
           MOVE CIFM TO CIF-DE
           MOVE DIRECCIONM TO DOMI-DE
           MOVE TELEFONOM TO TLF-DE
           MOVE CANTIDAD TO CANT-DE
           MOVE CONCEPTO TO OBJE-DE
           MOVE SERVI-AL TO SERV-DT
           MOVE TRATA-AL TO TRAT-DT
           MOVE IMPORTE TO PRE-DE
           WRITE IMPRE FROM CABEC1 AFTER 2 LINES
           WRITE IMPRE FROM FEC
           WRITE IMPRE FROM CABEC1 
           WRITE IMPRE FROM CABEC1-2 AFTER 3 LINES
           WRITE IMPRE FROM FEC6
           WRITE IMPRE FROM CABEC1-3
           WRITE IMPRE FROM CABEC1-4
           WRITE IMPRE FROM FEC1
           WRITE IMPRE FROM CABEC1-5
           WRITE IMPRE FROM FEC2
           WRITE IMPRE FROM FEC3
           WRITE IMPRE FROM FEC4.  

       PROCES-VISA.
             PERFORM VISU-PROA
             ACCEPT AVANZAR
             PERFORM LEER-SEC-MAEA.

       LEER-SEC-MAEA.
           READ ALBARAN NEXT RECORD, AT END MOVE "S" TO FIN. 

       VISU-PROA.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                          " 
                  LINE 8 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "VISUALIZACION DE ALBARAN"
                  LINE 9 POSITION 32 REVERSE
           DISPLAY " " LINE 9 POSITION 57 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 11 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "     "
                   LINE 12 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "   ALBARAN-NUM:"
                   LINE 12 POSITION 29 CONTROL "FCOLOR = GREEN"
           DISPLAY ALB-NUM 
                   LINE 12  POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY "               "
                   LINE 12 POSITION 50 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "ENTREGA:"
                   LINE 13 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY EMPRESAM
                   LINE 13 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "  " LINE 13 POSITION 63 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "LOCALIDAD:"
                   LINE 14 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY LOCALIDADM 
                   LINE 14 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "DIRECCION:"
                   LINE 15 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY DIRECCIONM 
                   LINE 15 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "TELEFONO:"
                   LINE 16 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY TELEFONOM 
                   LINE 16 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "               
                   LINE 16 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "C-POSTAL:"
                   LINE 17 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY C-POSTALM 
                   LINE 17 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                   LINE 17 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 18 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "CIF:" LINE 18 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY CIFM 
                   LINE 18 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 18 POSITION 40 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 19 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "CANTIDAD:"
                   LINE 19 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY CANTIDAD LINE 19 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "         "
                   LINE 19 POSITION 54 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 20 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "CONCEPTO:"
                   LINE 20 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY CONCEPTO LINE 20 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                   LINE 20 POSITION 40 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 21 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "PRECIO:" 
                   LINE 21 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY IMPORTE
                   LINE 21 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "     " LINE 21 POSITION 51    
           DISPLAY "                                          "
                   LINE 22 POSITION 24 CONTROL "BCOLOR = READ".

       FACTURA.
           PERFORM MENU-FACTURA UNTIL OPC-MENU = "5".

       MENU-FACTURA.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                LINE 8 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY "MENU FACTURACION"
                   LINE 9 POSITION 31 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 9 POSITION 40 CONTROL "BCOLOR = READ"
           DISPLAY "                       "
                   LINE 10 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 11 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "1>CONFIGURACION"
                   LINE 11 POSITION 30 CONTROL "FCOLOR = GREEN"
           DISPLAY "    " LINE 11 POSITION 43 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 12 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "2>MODIFICACION" 
                   LINE 12 POSITION 32 CONTROL "FCOLOR = GREEN"
           DISPLAY "     " 
                   LINE 12 POSITION 42 CONTROL "BCOLOR = READ"
           DISPLAY "       " 
                   LINE 13 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "3>ANULACION"
                   LINE 13 POSITION 34 CONTROL "FCOLOR = GREEN"
           DISPLAY "      "
                   LINE 13 POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY "        " 
                   LINE 14 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "4>LISTADO"
                   LINE 14 POSITION 35 CONTROL "FCOLOR = GREEN"
           DISPLAY "       " 
                   LINE 14 POSITION 43 CONTROL "FCOLOR = READ"
           DISPLAY "       " 
                   LINE 15 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "5>REGRESAR"
                   LINE 15 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "             "
                   LINE 15 POSITION 43 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                 LINE 16 POSITION 27 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 17 POSITION 37
           IF OPC-MENU = "1"
             PERFORM CONFIGURACIONF
           ELSE   
           IF OPC-MENU = "2"
             PERFORM MODIFICACIONF
           ELSE
           IF OPC-MENU = "3"
             PERFORM ANULACIONF
           ELSE
           IF OPC-MENU = "4"
             PERFORM LISTADOF
           ELSE
           IF OPC-MENU = "5"
             DISPLAY "FIN DE EJECUCION"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE"
           ELSE
             DISPLAY "ERROR"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE".

       CONFIGURACIONF.
           OPEN OUTPUT FACTURADO
                I-O ALBARAN, PAGO   
           MOVE LOW-VALUE TO ALB-NUM
           READ ALBARAN NEXT RECORD
           MOVE COD-CLID TO COD-CLIF 
           PERFORM PORCESO UNTIL FIN = "S"
           CLOSE FACTURADO, ALBARAN, MAESTRO. 

       PORCESO.
           IF COD-CLID = COD-CLIF
             ADD 1 TO CONTADOR5
             MOVE CONTADOR5 TO FACT-NUM
             ACCEPT FECHA FROM DATE
             STRING ANNO DELIMITED BY SIZE 
                    MES-ALB DELIMITED BY SIZE
                    DIA-ALB DELIMITED BY SIZE
                    INTO FECHAF 
             MOVE IMPORTE TO TOTAL-IMPORTE
             DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
             DISPLAY "INTRODUCE EL CODIGO DE FORMA DE PAGO"
                      LINE 12 POSITION 20
             ACCEPT COD-PAGO LINE 12 POSITION 50
             READ PAGO
             DISPLAY PLAZO, INTERES, PORCENTAJE LINE 14 POSITION 20
             DISPLAY "TANTO POR CIENTO DE LA BASE IMPONIBLE:?"
                     LINE 17 POSITION 20
             ACCEPT TANTO LINE 17 POSITION 62
             MOVE ZERO TO BASE-IMPOF
             COMPUTE BASE-IMPOF = IMPORTE * TANTO / 100
             WRITE R-FACTURADO
           ELSE
             DISPLAY "DESEAS FACTURAR OTRO?:"
                     LINE 18 POSITION 20
             ACCEPT RESP LINE 18 POSITION 45
             IF RESP = "S" OR RESP = "s"
               PERFORM PORCESO.        

       MODIFICACIONF.
           OPEN I-O FACTURADO
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE EL NUMERO DE FACTURA A TRATAR"
                   LINE 12 POSITION 20 
           ACCEPT FACT-NUM LINE 12 POSITION 60
           READ FACTURADO
           PERFORM VISU-PROF
           PERFORM VALIDARFAC UNTIL OPC-MENU = "S"
           REWRITE R-FACTURADO 
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "DESEAS MODIFICAR OTRA FICHA?:"
                    LINE 12 POSITION 20
           ACCEPT RESP LINE 12 POSITION 50
           IF RESP = "S" OR RESP = "s"
             PERFORM MODIFICACIONF.         
           CLOSE FACTURADO.           

       VALIDARFAC.
           DISPLAY "QUE CAMPO DESEAS MODIFICAR (S/SALIR):"
                   LINE 18 POSITION 30
           DISPLAY "1>ENTREGA/2>LOCALIDAD/3>DIRECCION"
                   LINE 19 POSITION 26
           DISPLAY "4>TELEFONO/5>BASE-IMP/6>IVAR"
                   LINE 20 POSITION 28
           ACCEPT OPC-MENU
           IF OPC-MENU = "1"
              ACCEPT EMPRESAM LINE 13 POSITION 33.
           IF OPC-MENU = "2"  
              ACCEPT LOCALIDADM LINE 14 POSITION 35.
           IF OPC-MENU = "3"
              ACCEPT DIRECCIONM LINE 15 POSITION 35.
           IF OPC-MENU = "4"
              ACCEPT TELEFONOM LINE 16 POSITION 34.
           IF OPC-MENU = "5"
              ACCEPT BASE-IMPOF LINE 17 POSITION 34.
           IF OPC-MENU = "6"
              ACCEPT IVA-REPER LINE 18 POSITION 29.
           IF OPC-MENU = "7"
              ACCEPT CANTIDAD LINE 19 POSITION 34.
           IF OPC-MENU = "8"
              ACCEPT CONCEPTO LINE 20 POSITION 25.
           IF OPC-MENU = "9"
              ACCEPT TOTAL-IMPORTE LINE 22 POSITION 32.

       ANULACIONF.
           OPEN I-O FACTURADO
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE EL NUMERO DE FACTURA A ANULAR"
                   LINE 12 POSITION 20
           ACCEPT FACT-NUM LINE 12 POSITION 61
           READ FACTURADO
           PERFORM VISU-PROF
           ACCEPT AVANZAR
           DISPLAY "CONFIRMA LA BAJA(S/N)"
               LINE 24 POSITION 35
           ACCEPT RESP LINE 24 POSITION 57
           IF RESP = "S" OR RESP = "s"
              DELETE FACTURADO RECORD.
           CLOSE FACTURADO. 

       LISTADOF.
           PERFORM MENU-LISTADOF UNTIL OPC-MENU = "3".

       MENU-LISTADOF.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                 "
                   LINE 16 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "MENU DE LISTADO"
                   LINE 17 POSITION 34 REVERSE
           DISPLAY " " LINE 17 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "                 "
                   LINE 18 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 19 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "1.>IMPRESORA"
                   LINE 19 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "                "
                   LINE 19 POSITION 49 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 20 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "2.>PANTALLA"
                   LINE 20 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "   "
                   LINE 20 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 21 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "3.>RETORNO"
                   LINE 21 POSITION 36 CONTROL "FCOLOR = GREEN"
           DISPLAY "    "
                   LINE 21 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "   " LINE 22 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " OPCION?:"
                   LINE 22 POSITION 36 REVERSE
           DISPLAY "   "
                   LINE 22 POSITION 47 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 22 POSITION 46 CONTROL "FCOLOR = READ"
           DISPLAY "                 "
                   LINE 23 POSITION 33 CONTROL "BCOLOR = READ"
           IF OPC-MENU = "1"
             PERFORM LISTADOF
           ELSE
             IF OPC-MENU = "2"
               OPEN INPUT FACTURADO
               MOVE LOW-VALUE TO FACT-NUM
               PERFORM LEER-SEC-MAEF
               MOVE "N" TO FIN
               PERFORM PROCES-VISF UNTIL FIN = "S"
               CLOSE FACTURADO
             ELSE
               IF OPC-MENU = "3"
                 DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
               ELSE
                 DISPLAY "ERROR", ERASE
                  LINE 12 POSITION 20 SIZE 80 CONTROL "BCOLOR = BLUE".    

       PROCES-VISF.
             PERFORM VISU-PROF
             ACCEPT AVANZAR
             PERFORM LEER-SEC-MAEF.

       LEER-SEC-MAEF.
           READ FACTURADO NEXT RECORD, AT END MOVE "S" TO FIN.

       VISU-PROF.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                          " 
                  LINE 8 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "VISUALIZACION DE FACTURA"
                  LINE 9 POSITION 32 REVERSE
           DISPLAY " " LINE 9 POSITION 57 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 11 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "               "
                   LINE 12 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "   FACTURA-NUM:"
                   LINE 12 POSITION 29 CONTROL "FCOLOR = GREEN"
           DISPLAY CLIENTEM 
                   LINE 12  POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY "               "
                   LINE 12 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "EMPRESA:"
                   LINE 13 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY EMPRESAM 
                   LINE 13 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 63 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "LOCALIDAD:"
                   LINE 14 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY LOCALIDADM 
                   LINE 14 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "DIRECCION:"
                   LINE 15 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY DIRECCIONM 
                   LINE 15 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 64 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "TELEFONO:"
                   LINE 16 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY TELEFONOM 
                   LINE 16 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "               
                   LINE 16 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "BASE-IMP:"
                   LINE 17 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY BASE-IMPOF
                   LINE 17 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                   LINE 17 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 18 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "IVAR" LINE 18 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY IVA-REPER
                   LINE 18 POSITION 29 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 18 POSITION 40 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 19 POSITION 24 CONTROL "BCOLOR = READ".

       LISTADO-AF.
           OPEN INPUT FACTURADO
                I-O  MAESTRO
           MOVE LOW-VALUE TO FACT-NUM
           MOVE "N" TO FIN 
           PERFORM LEER-SEC-MAEF
           PERFORM CABEF
           PERFORM B-LIF UNTIL FIN = "S".

       CABEF.
           WRITE IMPRE FROM CAB1-2 AFTER ADVANCING PAGE
           WRITE IMPRE FROM CABECERA2 AFTER 4 LINES.

       B-LIF.
           ACCEPT FECHA FROM DATE
           MOVE ANNO TO AN-DE
           MOVE MES-ALB TO MES-DE
           MOVE DIA-ALB TO DIA-DE
           MOVE COD-CLIF TO CLIENTE 
           READ MAESTRO RECORD
           MOVE EMPRESAM TO EMPRE-DE                   
           MOVE CIFM TO CIF-DE
           MOVE DIRECCIONM TO DOMI-DE
           MOVE TELEFONOM TO TLF-DE
           MOVE TOTAL-IMPORTE TO IMPOR-DE
           MOVE BASE-IMPOF TO BIMPO-DE
           MOVE IVA-REPER TO IVA-DE
           WRITE IMPRE FROM CABEC1 AFTER 2 LINES
           WRITE IMPRE FROM FEC
           WRITE IMPRE FROM CABEC1 
           WRITE IMPRE FROM CABEC1-2 AFTER 3 LINES
           WRITE IMPRE FROM FEC6
           WRITE IMPRE FROM CABEC1-3
           WRITE IMPRE FROM CABEC1-4
           WRITE IMPRE FROM FEC1
           WRITE IMPRE FROM CABEC1-5
           WRITE IMPRE FROM CABEC1-6
           WRITE IMPRE FROM FEC7. 

       RECIBO.
           PERFORM CONFIGR.

       CONFIGR.
           OPEN OUTPUT FACTURAS         
                I-O PROVEDOR, IVA
           ADD 1 TO CONTADOR6
           MOVE CONTADOR4 TO REC-NUM
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "COMO TRABAJAS POR CODIGO(C) O POR EMPRESA(E)"
                        LINE 12 POSITION 20
           ACCEPT FORMA LINE 12 POSITION 60
           IF FORMA = "C"
              DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
              DISPLAY "INTRODUCE EL CODIGO:"
                     LINE 12 POSITION 20
              ACCEPT PROVE LINE 12 POSITION 45
              READ PROVEDOR 
           ELSE
           IF FORMA = "E"
              DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
              DISPLAY "INTRODUCE LA EMPRESA:"
                      LINE 12 POSITION 20
              ACCEPT ENTERPRISE LINE 12 POSITION 47  
              READ PROVEDOR 
                 KEY IS ENTERPRISE.
           ACCEPT FECHA FROM DATE
           MOVE PROVE TO COD-PRO
           MOVE MES TO FECHAF
           DISPLAY " ", ERASE  SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE CODIGO DE IVA" 
                       LINE 12 POSITION 25
           ACCEPT COD-IVA LINE 12 POSITION 50
           READ IVA, INVALID KEY MOVE "N" TO EXISTE
           PERFORM IMPUES
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "INTRODUCE LA CANTIDAD COBRADA:"
                    LINE 12 POSITION 20
           ACCEPT COBRADO LINE 12 POSITION 52           
           WRITE R-ALBARAN
           DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "QUIERES METER OTRA?:"
                   LINE 12 POSITION 20
           ACCEPT RESP LINE 12 POSITION 52
           IF RESP = "S" OR RESP = "s"
               PERFORM CONFIGR
           END-IF.
           CLOSE ALBARAN, PEDIDO, MAESTRO, SERVICIOS, IVA. 

       IMPUES.
           IF EXISTE = "S"
              MOVE C-IVA TO IVA-SOPOR 
           ELSE
              DISPLAY " ", ERASE SIZE 80 CONTROL "BCOLOR = BLUE"
              DISPLAY "TECLEE CODIGO CORRECTO(1,2,3)"
                      LINE 12 POSITION 25
              READ IVA, INVALID KEY MOVE "N" TO EXISTE
              PERFORM IMPUES.                                       

       GESTION.  
           PERFORM CREACION
           PERFORM MENU-GESTION UNTIL OPC-MENU = "2".

       CREACION.
           OPEN OUTPUT DIARIO     
                I-O FACTURADO, FACTURAS
           MOVE LOW-VALUE TO FACT-NUM
           MOVE LOW-VALUE TO REC-NUM
           READ FACTURADO NEXT RECORD
           PERFORM CREA1 UNTIL FIN = "S"
           READ FACTURAS NEXT RECORD
           PERFORM CREA2 UNTIL FIN = "S"
           CLOSE DIARIO, FACTURADO, FACTURAS.

       CREA1.
           ADD 1 TO CONTADOR7
           MOVE CONTADOR7 TO NUM-FAC
           MOVE COD-CLIF TO COD-CLID
           MOVE FECHAF TO FECHA
           MOVE MES TO MES-D
           MOVE ANNO TO ANO-D
           MOVE BASE-IMPOF TO CLIENTEP
           MOVE IVA-REPER TO IVAR
           MOVE ZEROS TO PROV-DI
           MOVE ZEROS TO IVAS.

       CREA2.
           ADD 1 TO CONTADOR7
           MOVE CONTADOR7 TO NUM-FAC
           MOVE COD-PRO TO COD-CLID
           MOVE MES-R TO MES-D
           MOVE ZEROS TO CLIENTEP
           MOVE ZERO TO IVAR
           MOVE COBRADO TO PROV-DI
           MOVE IVA-SOPOR TO IVAS.

       MENU-GESTION.    
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                "
                LINE 8 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY "MENU DE GESTION "
                   LINE 9 POSITION 31 CONTROL "FCOLOR = GREEN"
           DISPLAY " " LINE 9 POSITION 47 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                   LINE 10 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 11 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "1>VISUALIZAR DIARIO:"
                   LINE 11 POSITION 28 CONTROL "FCOLOR = GREEN"
           DISPLAY "    " LINE 11 POSITION 48 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 12 POSITION 27 CONTROL "BCOLOR = READ"
           DISPLAY "2>REGRESAR"
                   LINE 12 POSITION 28 CONTROL "BCOLOR = READ"
           DISPLAY "             "
                   LINE 12 POSITION 38 CONTROL "BCOLOR = READ"
           DISPLAY "                        "
                 LINE 13 POSITION 27 CONTROL "BCOLOR = READ"
           ACCEPT OPC-MENU LINE 13 POSITION 36
           IF OPC-MENU = "1"
             MOVE LOW-VALUE TO NUM-FAC
             PERFORM LEER
             PERFORM VIS-DIARIO UNTIL AVANCE = "*"
           IF OPC-MENU = "2"
             DISPLAY "FIN DE EJECUCION"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE"
           ELSE
             DISPLAY "ERROR"
                ERASE LINE 12 POSITION 20 CONTROL "BCOLOR = BLUE".

       VIS-DIARIO.
           DISPLAY " " SIZE 80 CONTROL "BCOLOR = BLUE"
           DISPLAY "                          " 
                  LINE 8 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 9 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "VISUALIZACION DE DIARIO "
                  LINE 9 POSITION 32 REVERSE
           DISPLAY " " LINE 9 POSITION 57 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 10 POSITION 32 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 11 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "     "
                   LINE 12 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "  REGISTRO NUM:"
                   LINE 12 POSITION 29 CONTROL "FCOLOR = GREEN"
           DISPLAY NUM-FAC  
                   LINE 12  POSITION 36 CONTROL "BCOLOR = READ"
           DISPLAY "                       "
                   LINE 12 POSITION 42 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 13 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "COD-CLI:"
                   LINE 13 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY COD-CLID
                   LINE 13 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 13 POSITION 39 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 14 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "FECHA:"
                   LINE 14 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY MES-D, ANO-D
                   LINE 14 POSITION 30 CONTROL "BCOLOR = READ"
           DISPLAY "                           "
                   LINE 14 POSITION 38 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 15 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "CLIENTE:"
                   LINE 15 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY CLIENTEP  
                   LINE 15 POSITION 33 CONTROL "BCOLOR = READ"
           DISPLAY "                      " 
                   LINE 15 POSITION 42 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 16 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "PROVEEDOR:"
                   LINE 16 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY PROV-DI LINE 16 POSITION 35 CONTROL "BCOLOR = READ"
           DISPLAY "                     "               
                   LINE 16 POSITION 44 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 17 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "IVA-REPE:"
                   LINE 17 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY IVAR LINE 17 POSITION 34 CONTROL "BCOLOR = READ"
           DISPLAY "                    "
                   LINE 17 POSITION 45 CONTROL "BCOLOR = READ"
           DISPLAY " " LINE 18 POSITION 24 CONTROL "BCOLOR = READ"
           DISPLAY "IVA-SO:" 
                   LINE 18 POSITION 25 CONTROL "FCOLOR = GREEN"
           DISPLAY IVAS LINE 18 POSITION 31 CONTROL "BCOLOR = READ"
           DISPLAY "                          "
                   LINE 18 POSITION 40 CONTROL "BCOLOR = READ"
           DISPLAY "                                          "
                   LINE 19 POSITION 24 CONTROL "BCOLOR = READ"
           PERFORM LEER UNTIL FIN = "S"
           ACCEPT AVANCE.

       LEER.
           READ DIARIO NEXT RECORD, AT END MOVE "S" TO FIN.  

